; Compiler: Avrasm2

#define Simu_1
#ifdef Simu_1
#include "m8Adef.inc"
#endif ; Simu_1

;#define MODE24V
;#define MODE48V
#ifndef MODE24V
#ifdef MODE48V
#define MODE24V
#endif
#endif

;                 "1234567812345678
#define sourceP   "AmpereDC_16-01-1" ; of Project
#define sourceB   "AV16-01-1_______" ; for Boards
#define HEX_year  0x24
#define HEX_month 0x04
#define HEX_day   0x01

;====
.DSEG
;====

    .org 0x0060

DigtA1:   .Byte 1 ;60 _00.0 if positive
DigtA2:   .Byte 1 ;61 -00.0 if negative
DigtA3:   .Byte 1 ;62 current display

DigtV1:   .Byte 1 ;63 00.00
DigtV2:   .Byte 1 ;64
DigtV3:   .Byte 1 ;65 voltage display

DigtM1:   .Byte 1 ;66 00.00
DigtM2:   .Byte 1 ;67
DigtM3:   .Byte 1 ;68 mains voltage display

DgtVh1:   .Byte 1 ;69 00.00
DgtVh2:   .Byte 1 ;6A
DgtVh3:   .Byte 1 ;6B user high voltage

DgtCh1:   .Byte 1 ;6C 00.00
DgtCh2:   .Byte 1 ;6D
DgtCh3:   .Byte 1 ;6E user high current

DgtEr1:   .Byte 1 ;6F
DgtEr2:   .Byte 1 ;70
DgtEr3:   .Byte 1 ;71 erro code dsiplay

Digt_1:   .Byte 1 ;72
Digt_2:   .Byte 1 ;73
Digt_3:   .Byte 1 ;74 for SHWdspl

;===

sumCurrL: .Byte 1 ;75 reading current sum, low
sumCurrH: .Byte 1 ;76 reading current sum, high
sumCurrU: .Byte 1 ;77 reading current sum, upper

avgCurrL: .Byte 1 ;78 reading current average, low
avgCurrH: .Byte 1 ;79 reading current average, high

avgCtmpL: .Byte 1 ;7A reading current average for KEYSadj:, low
avgCtmpH: .Byte 1 ;7B reading current average for KEYSadj:, high

DECcurrL: .Byte 1 ;7C ADC current reading as DEC, see adjDECcH\L, low
DECcurrH: .Byte 1 ;7D ADC current reading as DEC, see adjDECcH\L, high

currG_L:  .Byte 1 ;7E ADC current reading to DEC, low
currG_H:  .Byte 1 ;7F ADC current reading to DEC, high

ZroDifL:  .Byte 1 ;80 adjusting zero current difference, low
ZroDifH:  .Byte 1 ;81 adjusting zero current difference, high

;===

sumVoltL: .Byte 1 ;82 reading voltage sum, low
sumVoltH: .Byte 1 ;83 reading voltage sum, high
sumVoltU: .Byte 1 ;84 reading voltage sum, upper

avgVoltL: .Byte 1 ;85 reading voltage average, low
avgVoltH: .Byte 1 ;86 reading voltage average, high

avgVtmpL: .Byte 1 ;87 reading voltage average for KEYSadj:, low
avgVtmpH: .Byte 1 ;88 reading voltage average for KEYSadj:, high

DECvoltL: .Byte 1 ;89 ADC voltage reading as DEC, see voltG_H\L, low
DECvoltH: .Byte 1 ;8A ADC voltage reading as DEC, see voltG_H\L, high

voltG_L:  .Byte 1 ;8B ADC voltage reading to DEC, low
voltG_H:  .Byte 1 ;8C ADC voltage reading to DEC, high

;===

sumMainL: .Byte 1 ;8D reading mains voltage sum, low
sumMainH: .Byte 1 ;8E reading mains voltage sum, high
sumMainU: .Byte 1 ;8F reading mains voltage sum, upper

avgMainL: .Byte 1 ;90 reading mains voltage average, low
avgMainH: .Byte 1 ;91 reading mains voltage average, high

avgMtmpL: .Byte 1 ;92 reading mains voltage average for KEYSadj:, low
avgMtmpH: .Byte 1 ;93 reading mains voltage average for KEYSadj:, high

mainG_L:  .Byte 1 ;94 ADC mains voltage reading to DEC, low
mainG_H:  .Byte 1 ;95 ADC mains voltage reading to DEC, high

DECmain:  .Byte 1 ;96 ADC mains voltage reading as DEC, see voltG_H\L, low

;=== ===

v_hiDecB: .Byte 1 ;97 byte of high limit voltage in EE
v_hiDecL: .Byte 1 ;98 high limit voltage as DEC binary, low
v_hiDecH: .Byte 1 ;99 high limit voltage as DEC binary, high
; v_hiDecH\L = v_hiDecB * 100

;===

c_hiDecB: .Byte 1 ;9A byte of low limit current in EE
c_hiDecL: .Byte 1 ;9B low limit current as DEC binary, low
c_hiDecH: .Byte 1 ;9C low limit current as DEC binary, high
; c_hiDecH\L = c_hiDecB * 100

;===

TmpDecB:  .Byte 1 ;9D byte of temporary entry voltage
TmpDecL:  .Byte 1 ;9E temporary entry voltage as binary, low
TmpDecH:  .Byte 1 ;9F temporary entry voltage as binary, high
; TmpDecH\L = TmpDecB * 100

;=== ===

scrDlyL:  .Byte 1 ;A0 for SCRNmod: [change screen mode], low
scrDlyH:  .Byte 1 ;A1 for SCRNmod: [change screen mode], high

TcountrL: .Byte 1 ;A2 counter delay for Key_hi or Key_lo, low
TcountrH: .Byte 1 ;A3 counter delay for Key_hi or Key_lo, high

ChrgDly:  .Byte 1 ;A4 delay counter to restart charge after current protection
TchgOut:  .Byte 1 ;A5 delay counter to restart charge after voltage protection

;=== ===

EEaddr_L: .Byte 1 ;A6 image of EEARL

;=== ===

dlyZero:  .Byte 1 ;A7
avgCzroL: .Byte 1 ;A8 reading current average for KEYSadj:, low
avgCzroH: .Byte 1 ;A9 reading current average for KEYSadj:, high

;=== ===

PWM_maxL: .Byte 1 ;AA maximum PWM duty cycle [top=364], low 
PWM_maxH: .Byte 1 ;AB maximum PWM duty cycle [top=364], high 

PWM_L:    .Byte 1 ;AC actual pulse width [OCR1AL], low
PWM_H:    .Byte 1 ;AD actual pulse width [OCR1AL], high

;=== ===

; for loop, to clear registers
.equ SRAMstr = 0x60             ; up to 0x00FF (160 SRAM bytes)
#define SRAMall                 ; to clear all 1024 registers [up to 0x0459]

;====
.CSEG
;====

;==========================
; **** SYSTEM constants ***
;==========================

; X2/TOSC2, X1/TOSC1, SCK, MISO, MOSI/OC2, SS/OC1B, OC1A, ICP1
; SW4=inP,Zky=inP,TIM=outL,Dgt3=inP,Dgt2=inP,Dgt1=outH,MOS=outH,Scn=inP
.equ DDRBini0 = 0b00100110      ; i i o iio oi
.equ PRTBini0 = 0b11011101      ; P P L PPH LP , no charge at boot

; *** outputs *** 5
#define MOS_Out PORTB,1

; PB4= Dgt3, PB3= Dgt2, PB2= Dgt1
; IMPORTANT: for DDRB (not PORTB), PORTB fixed & DDRB changed
.equ DIGITSof = 0b00100010      ; PPL LLL HP, all off
.equ DIGIT1on = 0b00100110      ; PPL LLH HP, Dgt1 only on
.equ DIGIT2on = 0b00101010      ; PPL LHL HP, Dgt2 only on
.equ DIGIT3on = 0b00110010      ; PPL HLL HP, Dgt3 only on

#define TIMEcalb PORTB,5

; *** inputs *** 1
#define SCNkeyIn PINB,0
#define ZERO_key PINB,6

; *** reserved ***
; PB6, PB7

;======

; N/A, RESET(inP), ADC5/SCL, ADC4/SDA, ADC3, ADC2, ADC1, ADC0
; N/A,RST=inP,SWup=inP,SWdw=inP,ADC_V=inT,SW3=inP,ADC_A=inT,ADC_M=inT
.equ DDRCini0  = 0b00000000     ; xiiiiiii
.equ PRTCini0  = 0b01110100     ; xPPPTPTT

; *** inputs *** 4
#define KEYupIn PINC,5
#define KEYdwIn PINC,4

#define KEYs_In  PINC
.equ NO_keys = 0b11111111
.equ TWOkeys = 0b11001111
.equ UP_keys = 0b11011111
.equ DW_keys = 0b11101111

; PC0= ADC_M PC1= ADC_A , PC3= ADC_V

; *** outputs *** 0
; none

; *** reserved *** 2+1[N/A]
; PC2, PC6 (reset), PC7 (N/A)

;======

; AIN1, AIN0, T1, XCK/T0, INT1, INT0, TXD, RXD
; SgB=inT,SgF=inT,SgA=inT,SgE=inT,SgD=inT,SgP=inT,SgC=inT,SgG=outL
; IMPORTANT: fix PORTD and change DDRD
.equ DDRDini0 = 0b00000001      ; iiiiiiio
.equ PRTDini0 = 0b00000000      ; TTTTTTTL

; *** inputs *** 0
; none

; *** outputs *** 8
.equ Seg_dot = 4
#define UPPboot DDRD,5          ; if 1, segmentA is lite, uppper seg
#define MIDboot DDRD,0          ; if 1, segmentG is lite, mid    seg
#define DWNboot DDRD,3          ; if 1, segmentD is lite, lower  seg

; PD7=Sg_B, PD6=Sg_F, PD5=Sg_A, PD4=Sg_E, PD3=Sg_D, PD1=Sg_C, PD0=Sg_G

; *** reserved *** 0
; none

;==========================
; *** PROGRAM constants ***
;==========================

#define b_ADIF   0x06,4 ; ADC Interrupt Flag
#define L_2V56   (1<<6|1<<7) ; ADC ref is 2V56
#define ADC0     0x00   ; mains_V input is ADC0
#define ADC1     0x01   ; current input is ADC1
#define ADC3     0x03   ; voltage input is ADC3

.equ ADC_main = L_2V56+ADC0      ; 2V56, right adjusted, Ampere  reading
.equ ADC_ampr = L_2V56+ADC1      ; 2V56, right adjusted, Ampere  reading
.equ ADC_volt = L_2V56+ADC3      ; 2V56, right adjusted, Voltage reading

; Enable, Start, Free Run Select, (2^6) 8000/(64)=125 KHz, 104us
.equ ADC_init = 1<<ADEN | 1<<ADSC | 1<<ADFR | 0x06  ; POLL b_ADIF
; ADEN , ADSC , ADFR , ADIF , ADIE , ADPS2 , ADPS1 , ADPS0
;  1      1      1      0      0      1       1       0

.equ ADCtime = 1040             ; for 104.0 us * 10

;.equ SMPLnmbr = 16              ; for ampere or voltage
.equ SMPLnmbr = 24              ; for ampere or voltage or mains

;.set KavgRd  = SMPLnmbr*120     ; (3 samples)*SMPLnmbr*120*104us~=900msec
.set Kavg_L=  low(SMPLnmbr*24)
.set Kavg_H= high(SMPLnmbr*24)+1; (3 samples)*SMPLnmbr*24*104us~=180msec
.set Kavg_N= 5                  ; 180msec*5 = 900msec
#ifdef Simu_1
.set Kavg_L=  low(SMPLnmbr*6)
.set Kavg_H= high(SMPLnmbr*6)+1 ; (3 samples)*SMPLnmbr*6*104us~=45msec
.set Kavg_N= 5                  ; 180msec*5=900msec
;.set KavgRd  = SMPLnmbr*120/4    ; (3 samples)*SMPLnmbr*30*104us~=225msec
#endif ; Simu_1

; 200ms/(ADCtime/10)/SMPLnmbr=80 ---> 0x0050
.equ KEYadjB = 200*1000                        ; see keyDlyH\L
.equ KEYadjH = high(10*KEYadjB/SMPLnmbr/ADCtime)+1
.equ KEYadjL =  low(10*KEYadjB/SMPLnmbr/ADCtime)

; 2s/(ADCtime/10)/SMPLnmbr=801 ---> 0x0321
.set DLYscrB = 2000*1000-704    ; see scrDlyH\L (SUBI 1)
#ifdef Simu_1
; 100ms/(ADCtime/10/SMPLnmbr=40 ---> 0x0028
.set DLYscrB = 100*1000-160     ; see scrDlyH\L (SUBI 1)
#endif ; Simu_1
.equ DLYscrH = high(10*DLYscrB/SMPLnmbr/ADCtime)
.equ DLYscrL =  low(10*DLYscrB/SMPLnmbr/ADCtime)

; 2s/(ADCtime/10)/SMPLnmbr=801 ---> 0x0321
.set KEYsavB = 2000*1000        ; see keyDlyH\L
#ifdef Simu_1
; 100ms/(ADCtime/10/SMPLnmbr=40 ---> 0x0028
.set KEYsavB = 100*1000         ; see keyDlyH\L
#endif ; Simu_1
.equ KEYsavH = high(10*KEYsavB/SMPLnmbr/ADCtime)+1
.equ KEYsavL =  low(10*KEYsavB/SMPLnmbr/ADCtime)

;=== ===

.equ ADDRc_h = 0x10             ; EEARL of currG_H , then currG_L
.equ ADDRv_h = 0x20             ; EEARL of voltG_H , then voltG_L
.equ ADDRm_h = 0x30             ; EEARL of voltG_H , then voltG_L
.equ ADDRvHi = 0x40             ; EEARL of v_hiUsrB
.equ ADDRcHi = 0x50             ; EEARL of c_hiUsrB
.equ ADDRzro = 0x60             ; EEARL of ZroDifH\L

;=== ===

.equ Cur2bcd = 4200             ; 0x1068, nominal of currG_H\L
.equ CurAdjt = 1000             ; 0x2710 [10A]
.equ For09A0 = Cur2bcd*10/9     ; 0x123A\4666, current adjust lowest  limit
.equ For11A0 = Cur2bcd*10/11    ; 0x0EEA\3818, current adjust highest limit

.set VltAdjt = 12000            ; 0x2EE0
.equ Vlt2bcd = 5196             ; 0x144C, nominal of voltG_H\L
.equ For11V0 = Vlt2bcd*24/22    ; 0x1624, [5668] voltage adjust lowest  limit
.equ For12V5 = Vlt2bcd*24/25    ; 0x137C, [4988] voltage adjust highest limit

.equ MviAdjt = 22000            ; 0x55F0
.equ Mvi2bcd = 10192            ; 0x27D0, 330n nominal of mainG_H\L

;---

; fixed
.equ VltHiB = 160               ; for 16V0, highest voltage limit
.equ VltHiW = VltHiB*100

.equ INITvHi = 145              ; for 14V5, initial high voltage limit

; fixed
.equ VltLoB = 135               ; for 13V5,  lowest high voltage limit
.equ VltLoW = VltLoB*100

; fixed
.equ v_loDecB = 12900           ; 12.9V, recharge if below it

;---

; fixed
.equ AmpHiB = 25                ; for 25A, highest current limit
.equ AmpHiW = AmpHiB*100

.equ INITcHi  = 20              ; for 20A, initial high current limit

; fixed
.equ AmpLoB  = 5                ; for 12V0, lowest  low limit
.equ AmpLoW  = AmpLoB*100

.equ AmpMxB = 25                ; for 25A, maximum current before cut delay
.equ AmpMxW = AmpMxB*100

;===

.set BOOTdly = 3000/2           ; 3000 ms / 2ms [display refresh]
#ifdef Simu_1
.set BOOTdly = 100/2            ; 300  ms / 2ms [display refresh]
#endif ; Simu_1

.equ ZROlimt = 300*256/Cur2bcd  ;=18, for +/-3A, limit of zero reference

; *2 because TcountrH\L is incremented twice (KEYhigh: & KEY_low:)
; 10,223,616us/104us/SMPLnmbr *2 = 8192 ---> 0x2000
.set USRoutB = 10223616*2     ; see TcountrH
#ifdef Simu_1
; 638,976us/104us/SMPLnmbr *2 = 512 ---> 0x0200
.set USRoutB = 638976*2       ; see TcountrH
#endif ; Simu_1
.equ USRoutH = high(USRoutB/SMPLnmbr/104) ; to exit prog mode

; 3,833,856us/104us/SMPLnmbr *2 = 3072 ---> 0x0C00
.set USRprgB = 3833856*2      ; see TcountrH
#ifdef Simu_1
; 319,488us/104us/SMPLnmbr *2 = 256 ---> 0x0100
.set USRprgB = 319488*2       ; see TcountrH
#endif ; Simu_1
.equ USRprgH = high(USRprgB/SMPLnmbr/104) ; to enter prog mode

; 638,976us/104us/SMPLnmbr *2 = 512 ---> 0x0200
.set USRrptB = 638976*2      ; see TcountrH
#ifdef Simu_1
; 319,488us/104us/SMPLnmbr *2 = 256 ---> 0x0100
.set USRrptB = 319488*2      ; see TcountrH
#endif ; Simu_1
.equ USRrptH = high(USRrptB/SMPLnmbr/104) ; to repeat update

.set ADJdly1 = 8
.set ADJdly2 = 35+1
#ifdef Simu_1
.set ADJdly1 = 1
.set ADJdly2 = 2+1
#endif ; Simu_1

.set simuDly = 250
#if defined Simu_1
.set simuDly = 1                ; for DLYqSec
#endif ; Simu_1

; Fast PWM, Compare Output Mode
; Fast PWM, TOP=ICR1
; Clear OC1A on Compare Match, set OC1A at BOTTOM, (non-inverting mode)
; OC1B disconnected, Normal port operation.
; clk / 1
.equ TCCR1Arun = 0b10000010
.equ TCCR1Brun = 0b00011001

.equ TCCR1Astp = 0b00000010
.equ TCCR1Bstp = 0b00011000

.equ PWM_top = 364

;=============================
; *** PROGRAM hi-registers ***
;=============================
; specific hi-registers
.def R1flags  = r25   ; ampere and voltage flags 1
.def R2flags  = r24   ; keys flags 2
.def R3flags  = r23   ; AH flags 3

; Division 24/16, 414 cycles, no rounding ***
; D16u16rd: , D24u16u:
.def steps = r21      ; loop counter
.def dv_H  = r20      ; divisor, high
.def dv_L  = r19      ; divisor, low
.def dd_U  = r18      ; divident, upper [ destroyed ]
.def dd_H  = r17      ; divident, high  [ destroyed ]
.def dd_L  = r16      ; divident, low   [ destroyed ]

.def rmd_H = r14      ; remainder, high
.def rmd_L = r13      ; remainder, low
.def res_U = r2       ; result, upper
.def res_H = r1       ; result, high
.def res_L = r0       ; result, low

; GLOBAL  hi-registers
;.def tmpHiQ   = r19   ; tempprary register
;.def tmpHiU   = r18   ; tempprary register
;.def tmpHiH   = r17   ; tempprary register
;.def tmpHiL   = r16   ; tempprary register

;=============================
; *** PROGRAM lo-registers ***
;=============================
; GLOBAL  lo-registers
.def zero     = r15   ; for 0 value
;.def tmpLoH   = r14   ; temporary for program
;.def tmpLoL   = r13   ; temporary for program

; specific lo-registers
.def avgCt_N  = r12   ; average Amp and Vlt counter
.def avgCt_H  = r11   ; average mains voltage counter
.def avgCt_L  = r10   ;

.def curSmpl  = r9    ; for IJMP and find average
.def curSubS  = r8    ; for select ADC reading

.def keyDlyH  = r7    ; KY_dlyH\L,KEYadjH\L,KEYsavH\L,KEYscrH delays
.def keyDlyL  = r6    ;

.def digtN    = r5    ; current display digit
.def DspOff   = r4    ; DspOff=0, offtime=256*16*104us=426ms

; r1 & r0 for MUL and others

.equ REGstr = 1
.equ REGend = 25      ; for loop to clear registers

;======================
; *** PROGRAM flags ***
;======================
; Bx for JBR, JNBR
; Fx for SBR, CBR

;.def R1flags  = r25       ; general flags 1, basic
#define B_newAmp r25,7     ; 1 = ADC current reading ready
#define F_newAmp r25,0x80

#define B_doAvgV r25,6     ; 1 = do average of voltage readings
#define F_doAvgV r25,0x40

#define B_newVlt r25,5     ; 1 = ADC voltage reading ready
#define F_newVlt r25,0x20

#define B_ampNeg r25,4     ; 1 = current sign (displayed in reverse)
#define F_ampNeg r25,0x10  ;                  (also reversed for AH)

#define B_ampMod r25,3     ; 1 = ampere mode
#define F_ampMod r25,0x08

#define B_vltMod r25,2     ; 1 = volt mode
#define F_vltMod r25,0x04

#define B_voltHi r25,1     ; 1 = signal high battery voltage
#define F_voltHi r25,0x02

#define B_dspOff r25,0     ; 1 = temporary display off
#define F_dspOff r25,0x01
#define X_dspOff 0b00000001

;---

;.def R2flags  = r24       ; general flags 2, basic
#define B_kyHiOn r24,7     ; 1 = increase current/volatge gain
#define F_kyHiOn r24,0x80

#define B_kyLoOn r24,6     ; 1 = decrease current/voltage gain
#define F_kyLoOn r24,0x40

#define B_usrVhi r24,5     ; 1 = user prog mode for high voltage
#define F_usrVhi r24,0x20  ; 1 = show v_hiDecB

#define B_usrChi r24,4     ; 1 = user prog mode for high current
#define F_usrChi r24,0x10  ; 1 = show c_hiDecB

#define B_key_Sv r24,3     ; 1 = save current gain index x
#define F_key_Sv r24,0x08

#define B_keyDly r24,2     ; 1 = inhibit a new key press and key reset
#define F_keyDly r24,0x04

#define B_busyEE r24,1     ; 1 = for saving a byte without wait
#define F_busyEE r24,0x02

#define B_doAvgM r24,0     ; 1 = do average of mains voltage readings
#define F_doAvgM r24,0x01

;===

;.def R3flags  = r23       ; AH flags 3
#define B_adjMod r23,3     ; 1 = adjust current, voltage, mainsV modes
#define F_adjMod r23,0x08

#define B_pass_1 r23,2     ; 1 = first pass of user hi or lo key
#define F_pass_1 r23,0x04

#define B_currHi r23,1     ; 1 = signal very high charging current
#define F_currHi r23,0x02  ;     also for display on-off

#define B_shwLmt r23,0     ; 1 = show low limit at boot, for SHWdspl:
#define F_shwLmt r23,0x01

;===

.equ UBRRLs = 0x09         ; flags
;---------------------------------
#define S_Gi_Set 0x09,7    ; 1 = set current gain before saving
#define S_Gi_Sav 0x09,6    ; 1 = save current gain
#define S_Gv_Set 0x09,5    ; 1 = set voltage gain before saving
#define S_Gv_Sav 0x09,4    ; 1 = save voltage gain
#define S_vHiSav 0x09,3    ; 1 = save user high voltage
#define S_cHiSav 0x09,2    ; 1 = save user  low voltage
#define S_zroSav 0x09,1    ; 1 = save ZroDifH\L in EE

.equ TWARs = 0x02          ; flags
;---------------------------------
#define S_Do_Rst 0x02,7    ; 1 = break KEYhigh: or KEY_low:
#define S_ovrNeg 0x02,6    ; 1 = current < AmpMxW [decrease cutOff counter]
#define S_iniZro 0x02,5    ; 1 = first zero is set/save [B_adjMod=1]

#define S_pwmMod 0x02,3    ; 1 = PWM is running

#define S_mviMod 0x02,2    ; 1 = mode of mains voltage adjust
#define S_Gm_Set 0x02,1    ; 1 = set mains voltage gain before saving
#define S_Gm_Sav 0x02,0    ; 1 = save mains voltage gain

;=========================================================================

    .org 0x0000

; MCUCSR: * , * , * , * , WDRF , BORF , EXTRF , PORF
    rjmp RESET      ; Reset Handler

    rjmp EXT_INT0   ; IRQ0 Handler
    rjmp EXT_INT1   ; IRQ1 Handler
    rjmp TIM2_COMP  ; Timer2 Compare Handler
    rjmp TIM2_OVF   ; Timer2 Overflow Handler
    rjmp TIM1_CAPT  ; Timer1 Capture Handler
    rjmp TIM1_COMPA ; Timer1 CompareA Handler
    rjmp TIM1_COMPB ; Timer1 CompareB Handler
    rjmp TIM1_OVF   ; Timer1 Overflow Handler
    rjmp TIM0_OVF   ; Timer0 Overflow Handler
    rjmp SPI_STC    ; SPI Transfer Complete Handler
    rjmp USART_RXC  ; USART RX Complete Handler
    rjmp USART_UDRE ; UDR Empty Handler
    rjmp USART_TXC  ; USART TX Complete Handler
    rjmp ADC_RDY    ; ADC Conversion Complete Handler
    rjmp EE_RDY     ; EEPROM Ready Handler
    rjmp ANA_COMP   ; Analog Comparator Handler
    rjmp TWSI       ; Two-wire Serial Interface Handler
    rjmp SPM_RDY    ; Store Program Memory Ready Handler

;---------------------
; 16 bytes Name & City
;---------------------

SIGNAT0:
   .db "AUTOLIGHT-ALEPPO"

SIGNAT1:
   .db  0x00, HEX_year, HEX_month, HEX_day ; number of bytes should be even
SIGNAT2:
   .db  sourceP
   .db  sourceB

   .db  __DATE__
   .db  __TIME__

;=============================
; *RI* Interrupts Handlers ***
;=============================

; IRQ0: PD2, pin4 [MCUCR , GICR , GIFR]
EXT_INT0:
    RETI

; IRQ1: PD3, pin5 [MCUCR , GICR , GIFR]
EXT_INT1:
    RETI

; Timer2 Compare: [TCCR2 , ASSR , TCNT2 , OCR2 , TIMSK , TIFR]
TIM2_COMP:
    RETI

; Timer2 Overflow: [TCCR2 , ASSR , TCNT2 , OCR2 , TIMSK , TIFR]
TIM2_OVF:
    RETI

; Timer1 Capture: [TCCR1A/B,TCNT1H/L,OCR1AH/L,OCR1BH/L,ICR1H/L,TIMSK ,TIFR]
TIM1_CAPT:
    RETI

; Timer1 CompareA: [TCCR1A/B,TCNT1H/L,OCR1AH/L,OCR1BH/L,ICR1H/L,TIMSK ,TIFR]
TIM1_COMPA:
    RETI

; Timer1 CompareB: [TCCR1A/B,TCNT1H/L,OCR1AH/L,OCR1BH/L,ICR1H/L,TIMSK ,TIFR]
TIM1_COMPB:
    RETI

; Timer1 Overflow: [TCNT1H/L, TIMSK , TIFR]
TIM1_OVF:
    RETI

; Timer0 Overflow: [TCCR0 , TCNT0]
TIM0_OVF:           ; TCNT0 [if TCCR0=0x00 always]
    RETI

; SPI Transfer Complete: [SPCR , SPSR , SPDR]
SPI_STC:            ;
    RETI

; USART: RX Complete: [UDR , UDR , UBRRL , UCSRA , UCSRB]
USART_RXC:
    RETI

; USART: UDR Empty: [UDR , UDR , UBRRL , UCSRA , UCSRB]
USART_UDRE:
    RETI

; USART: TX Complete: [UDR , UDR , UBRRL , UCSRA , UCSRB]
USART_TXC:
    RETI

; ADC Conversion Complete: [ADCH/L , ADMUX , ADCSRA]
ADC_RDY:            ;
    RETI

; EEPROM Ready: [EEARH/L, EEDR , EECR]
EE_RDY:
    RETI

; Analog Comparator: [SFIOR , ACSR]
ANA_COMP:
    RETI

; Two-wire Serial Interface: [TWAR , TWDR , TWBR , TWCR , TWSR]
TWSI:
    RETI

; Store Program Memory Ready: [SPMCR]
SPM_RDY:
    RETI

;===================
; *** MAIN entry ***
;===================

RESET:
; SPH\L [Stack Pointer] = RAMEND [top of SRAM, 0x045F]
    LDI   r16,  low(RAMEND)
    LDI   r17, high(RAMEND)
    OUT   SPL, r16
    OUT   SPH, r17

; DDRB=DDRBini0
    LDI   r16, DDRBini0
    OUT   DDRB, r16
; PORTB=PRTBini0
    LDI   r17, PRTBini0
    OUT   PORTB, r17

; DDRC=DDRCini0
    LDI   r16, DDRCini0
    OUT   DDRC, r16
; PORTC=PRTCini0
    LDI   r17, PRTCini0
    OUT   PORTC, r17

; DDRD=DDRDini0
    LDI   r16, DDRDini0
    OUT   DDRD, r16
; PORTD=PRTDini0
    LDI   r17, PRTDini0
    OUT   PORTD, r17

; Wait for stable Vcc (the fuse BODEN should be enabled)
    IN    r16, MCUCSR           ; MCU Control and Status Register
    SBRS  r16, BORF             ; Test Brown-out Reset Flag
    RJMP  RST_cnt               ; Continue if 0

    CLR   r16                   ; Brown-out Reset Flag is 1
    OUT   MCUCSR, r16           ; Clear all flags
    RJMP  RESET                 ;  and reboot

;====================================================================
; clear low and high registers
RST_cnt:
    CLR   r0
    LDI   XH, high(REGstr)
    LDI   XL,  low(REGstr)      ; start of variables in low registers
CLR_lp1:
    ST    X+, r0
    CPI   XL, REGend+1          ; end of variables in high registers
    BREQ  CLRend1

    RJMP  CLR_lp1

CLRend1:
; clear extended static RAM registers
    LDI   XH, high(SRAMstr)
    LDI   XL,  low(SRAMstr)     ; 0x60
CLR_lp2:
    ST    X+, r0

#ifndef SRAMall
    TST   XL
    BREQ  CLRend2               ; 0x60 =< XL =< 0xFF (160)

    RJMP  CLR_lp2
#else ; no SRAMall
    CPI   XH, high(RAMEND+1)    ; 0x04 , RAMEND+1 = 0x0460
    BRLO  CLR_lp2
    CPI   XL,  low(RAMEND+1)    ; 0x60
    BRLO  CLR_lp2
#endif ; SRAMall


CLRend2:
    OUT   UBRRLs, r0            ; r0 already cleared
    OUT   TWARs, r0

;==========================================
; ============ init variables =============
;==========================================

; check if office adjust [UP_keys, TWOkeys, DW_keys]
; < comment if Simu_1>
;    RCALL ISadjst

; < no comment if Simu_1 and adjust mode test>
;    SBR   F_adjMod

;/* <no comment if Simu_1 and user mode test>
; if Simu_1, press UP_keys [right] then release for adjust mode 
    IN    r16, KEYs_In
    ORI   r16, TWOkeys
    CPI   r16, UP_keys
    BRNE  SIMUtst

    SBR   F_adjMod

LOOPtst:
    IN    r16, KEYs_In
    ORI   r16, TWOkeys
    CPI   r16, UP_keys
    BREQ  LOOPtst
SIMUtst:
;*/ ; <no comment if Simu_1>

    LDI   r16, SEGS_d_
    STS   DigtA3, r16
    STS   DigtV3, r16

    LDI   r16, SEGS_c_
    STS   DigtA2, r16
    STS   DigtV2, r16

    LDI   r16, SEGS_2_          ; dc2
    STS   DigtA1, r16
    STS   DigtV1, r16

; init Cur2bcd, Vlt2bcd, INITvHi, INITcHi  in EE if fresh
    RCALL EE_init

; download current gain, currG_H\L
    RCALL RDcurrG

; download voltage gain, voltG_H\L
    RCALL RDvoltG

; download mains voltage gain, mainG_H\L
    RCALL RDmainG

; download: high limit voltage v_hiBinB, set v_hiBinH\L
    RCALL RD_V_hi

; download: high limit current c_hiUsrB, set c_hiUsrH\L
    RCALL RD_C_hi

; download: current zero offset
    RCALL RDzroDf

;===

; registers initialization
    SBR   F_ampMod              ; start as Ampere meter

    SBRC  B_adjMod
    RJMP  NOintro

; <no comment if Simu_1>
    RJMP  NOintro

    SBR   F_shwLmt

    LDI   r16,  low(BOOTdly)    ; 1500*2ms = 3 sec
    MOV   keyDlyL, r16
    LDI   r16, high(BOOTdly)+1
    MOV   keyDlyH, r16
    RCALL SHOWvLp

    SBR   F_usrVhi
    RCALL SHOWlmt
    CBR   F_usrVhi
    SBR   F_usrChi
    RCALL SHOWlmt
    CBR   F_usrChi

    CBR   F_shwLmt

;===

NOintro:
; Kavg_H\L=24*24=576=0x0240, [3]*24*24*104us ~= 180 msec
    LDI   r16, low(Kavg_L)
    MOV   avgCt_L, r16
    LDI   r17, low(Kavg_H)
    MOV   avgCt_H, r17
; Kavg_N=5, 5*[3]*24*24*104us ~= 900 msec
    LDI   r18, low(Kavg_N)
    MOV   avgCt_N, r18
; note: if <Simu_1>, 900 msec /4 = 225 msec

;===

    LDI   r16, 1
    STS   scrDlyL, r16
    STS   scrDlyH, zero

    RCALL DLYqSec

    OUT   OCR1AH, zero          ;1a
    OUT   OCR1AL, zero          ;1a

; Fast PWM, Compare Output Mode
; Fast PWM, TOP=ICR1
; Clear OC1A on Compare Match, set OC1A at BOTTOM, (non-inverting mode)
; OC1B disconnected, Normal port operation.
; clk / 1
    LDI   r16, TCCR1Astp        ; 0b00000010 [run=0b10000010]
    OUT   TCCR1A, r16
    LDI   r16, TCCR1Bstp        ; 0b00011000 [run=0b00011001]
    OUT   TCCR1B, r16
    CBI   S_pwmMod

;===

    LDI   r16, 1                ;1ac
    MOV   curSubS, r16          ;1ac

; init ADC for Irms
    LDI   r16, ADC_ampr         ; 2V56, ADC1, right adj. for Ampere
    OUT   ADMUX, r16

; Enable, Start Conversion, Free Running Select, (2^6) 8000/(64)=125 KHz
    LDI   r16, ADC_init         ; free at 125 KHz, 13/0.125 = 104us
    OUT   ADCSRA, r16

; <Simu_bug> after ADC enabled, 25 cycles not 13 cycles. 
MAINini:
; loop till ADC ends
    SBIS  b_ADIF
    RJMP  MAINini

; clear ADC flag [ by setting it to 1 ]
    SBI   b_ADIF

;------------------
; *** Main Loop ***
;------------------

MAIN_lp:
; loop till ADC ends
    SBIS  b_ADIF                ;2abc
    RJMP  MAIN_lp

; clear ADC flag [ by setting it to 1 ]
    SBI   b_ADIF                ;2abc

    SBI   TIMEcalb              ;2abc, PC2, p25

; Common code
    IN    r0, ADCL              ;1abc
    IN    r1, ADCH              ;1abc

    TST   curSubS               ;1abc
    BREQ  ADCcurr               ;1a/2bc [12b]

    DEC   curSubS               ;1ac
    BREQ  ADCmvi_               ;1a/2c [15c]

    RJMP  ADCvolt               ;2a [15a]

ADCmvi_:
    RJMP  ADCmvIn               ;2a [15a]

;===

ADCvolt:
; r18:r16 = r1:r0 + sumVoltU\H\L
    LDS   r16, sumVoltL         ;2c
    LDS   r17, sumVoltH         ;2c
    LDS   r18, sumVoltU         ;2c
    ADD   r16, r0               ;1c
    ADC   r17, r1               ;1c
    ADC   r18, zero             ;1c

; sumVoltU\H\L = r18:r16
    STS   sumVoltL, r16         ;2c
    STS   sumVoltH, r17         ;2c
    STS   sumVoltU, r18         ;2c

    SBRS  B_doAvgV              ;2c
    RJMP  SUMvltC

; [ r18:r16 = last sumVoltU\H\L ]
; clear sumVoltU\H\L
    STS   sumVoltU, zero        ;2c
    STS   sumVoltH, zero        ;2c
    STS   sumVoltL, zero        ;2c

; avgVoltH\L = sumVoltU\H\L / (24*120) = r18:r16 / (24*120)
; avgVoltH\L = r18:r16 /64 *1456/256/256
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a

;/* ; < no comment if Simu_1> /16
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
;*/ ; < no comment if Simu_1>

; r18:r17 = r18:r17 * 1456 / 256/256 [/45]    
    MOV   r13, r17
    MOV   r14, r18
    LDI   r16,  low(1456)
    LDI   r17, high(1456)

; r21:r20:r19:r18 = r17:r16 * r14:r13
; r21:r20 = [sumVoltU\H\L/64] /45
    RCALL M_16x16               ;+23a [23a+23a=46a] 

; save final average voltage   [ avgVoltH\L , reference 0 ]
    STS   avgVoltL, r20         ;2c
    STS   avgVoltH, r21         ;2c

; signal final voltage sum is ready   [ F_newVlt ]
    CBR   F_doAvgV              ;1c
    SBR   F_newVlt              ;1c

SUMvltC:
    RJMP  MAINnxt               ;2c +39c [15c+39c=54c]

;=== ===

ADCcurr:
; 3 consecutive readings
    LDI   r16, 2                ;1b
    MOV   curSubS, r16          ;1b

; r18:r16 = r1:r0 + sumCurrU\H\L
    LDS   r16, sumCurrL         ;2b
    LDS   r17, sumCurrH         ;2b
    LDS   r18, sumCurrU         ;2b
    ADD   r16, r0               ;1b
    ADC   r17, r1               ;1b
    ADC   r18, zero             ;1b

; sumCurrU\H\L = r18:r16
    STS   sumCurrL, r16         ;2b, update sumCurrU\H\L
    STS   sumCurrH, r17         ;2b
    STS   sumCurrU, r18         ;2b

; decrement avgCt_H\L if not zero , goto MAINnxt   [ 852 msec ]
    DEC   avgCt_L               ;1b
    BRNE  MAINcnt               ;1b

    DEC   avgCt_H               ;1b
    BREQ  MVINvlt               ;2b +22b [12b+22b=34b]

MAINcnt:
    RJMP  MAINnxt

;===

MVINvlt:
; 24*24=576=0x0240, [3]*24*24*104us ~= 180 msec
    LDI   r19, low(Kavg_L)      ;1b
    MOV   avgCt_L, r19          ;1b
    LDI   r19, low(Kavg_H)      ;1b
    MOV   avgCt_H, r19          ;1b

; signal end of display samples [for mains voltage average , F_doAvgM]
    SBR   F_doAvgM              ;1b

    DEC   avgCt_N               ;1b
    BRNE  MAINnxt               ;1b +13b [34b+13b=47b]

;===

MAINcur:
    LDI   r19, Kavg_N           ;1b
    MOV   avgCt_N, r19          ;1b

; signal end of display samples [for voltage average , F_doAvgV]
    SBR   F_doAvgV              ;1b

; signal display ampere sum is ready   [ F_newAmp ]
    SBR   F_newAmp              ;1b

; [ r18:r16 = last sumCurrU\H\L ]
; clear sumCurrU\H\L
    STS   sumCurrL, zero        ;2b
    STS   sumCurrH, zero        ;2b
    STS   sumCurrU, zero        ;2b

; avgCurrH\L = sumCurrU\H\L / (24*120) = r18:r16 / (24*120)
; avgCurrH\L = r18:r16 /64 *1456/256/256
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a

;/* ; < no comment if Simu_1> /16
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
;*/ ; < no comment if Simu_1>

; r18:r17 = r18:r17 * 1456 / 256/256 [/45]    
    MOV   r13, r17
    MOV   r14, r18
    LDI   r16,  low(1456)
    LDI   r17, high(1456)

; r21:r20:r19:r18 = r17:r16 * r14:r13
; r21:r20 = [sumCurrU\H\L/64] /45
    RCALL M_16x16               ;+23a [23a+23a=46a] 

    STS   avgCzroL, r20         ;2b, for zero set in adjust mode
    STS   avgCzroH, r21         ;2b

    LDS   r16, ZroDifL          ;2b
    LDS   r17, ZroDifH          ;2b
    SUB   r20, r16              ;1b
    SBC   r21, r17              ;1b

; save final average current   [ reference 511 ]
    STS   avgCurrL, r20         ;2b
    STS   avgCurrH, r21         ;2b +34b [47b+34b=81b]

;===

MAINnxt:
; increment curSmpl   [ for IJMP via (Z) ]
    INC   curSmpl               ;1abc
    MOV   r16, curSmpl          ;1abc
    CPI   r16, SMPLnmbr         ;1abc
    BRLO  MAINend               ;1abc

; if curSmpl >= SMPLnmbr , clear curSmpl
    CLR   curSmpl               ;1abc
MAINend:
; ijump , indirect SMPL000 + curSmpl   [ word address ]
    LDI   ZH, high(SMPL000)     ;1abc
    MOV   ZL, curSmpl           ;1abc
    IJMP                        ;4abc +11abc
; [32a+11a=43a] [81b+11b=92b] [54cb+11c=65c]

;=== ===

ADCmvIn:
; r18:r16 = r1:r0 + sumMainU\H\L
    LDS   r16, sumMainL         ;2a
    LDS   r17, sumMainH         ;2a
    LDS   r18, sumMainU         ;2a
    ADD   r16, r0               ;1a
    ADC   r17, r1               ;1a
    ADC   r18, zero             ;1a

; sumMainU\H\L = r18:r16
    STS   sumMainL, r16         ;2a
    STS   sumMainH, r17         ;2a
    STS   sumMainU, r18         ;2a

    RJMP  MAINnxt               ;2a +17a [15a+17a=32a]

;--------------------------------------
;SMPL000: avgCurrH\L to decCurrH\L  ***
;--------------------------------------

CUR2dec:
; if not B_newAmp, goto CURsegE
    SBRS  B_newAmp              ;2a
    RJMP  CURsegE

; assume it is positive
    CBR   F_ampNeg              ;1a

; r17:r16 = avgCurrH\L - 511
    LDS   r17, avgCurrH         ;2a, get final average current
    LDS   r16, avgCurrL         ;2a
    SUBI  r16, low(511)         ;1a, Subtract low bytes
    SBCI  r17, high(511)        ;1a, Subtract high byte with carry
    BRCC  CURabsE               ;1a, continue if positive

    SBR   F_ampNeg              ;1a, signal it is negative
; incverting all bits then adding one (two's complement)
    COM   r16                   ;1a, Invert low byte
    COM   r17                   ;1a, Invert high byte
    SUBI  r16,  low(-1)         ;1a, Add 0x0001, low byte
    SBCI  r17, high(-1)         ;1a, Add high byte

CURabsE:
; re-save avgCurrH\L as absolute
    STS   avgCurrH, r17         ;2a
    STS   avgCurrL, r16         ;2a

; decCurrH\L = avgCurrH\L * currG_H/L / 256 if < 0x2700 = 9984
    LDS   r14, currG_H          ;2a, 0x0FA0
    LDS   r13, currG_L          ;2a [23a] 
; r21:r20:r19:r18 = r17:r16 * r14:r13
; r20:r19 = decCurrH\L
    RCALL M_16x16               ;+23a [23a+23a=46a] 
    TST   r21                   ;1a
    BREQ  CURdec1               ;2a +3a [46a+3a=49a]

    LDI   r20, 0x27
    LDI   r19, 0x06             ; result as 9990
    RJMP  CURdec2

CURdec1:
; if decCurrH\L > 9983 , set as 9980
    CPI   r19,  low(9980)       ;1a
    LDI   r21, high(9980)       ;1a
    CPC   r20, r21              ;1a
    BRLO  CURdec2               ;1a

    LDI   r20, 0x26             ;1a
    LDI   r19, 0xFC             ;1a, result as 9980

CURdec2:
    STS   decCurrH, r20         ;2a
    STS   decCurrL, r19         ;2a +10a [49a+10a=59a]

CURsegE:
    RJMP  END_act               ;2a, +2a [59a+2a=61a] of SMPL000

;--------------------------------------
;SMPL001: avgVoltH\L to DECvoltH\L  ***
;--------------------------------------

VLT2dec:
; if not B_newVlt [display] , goto VLTsegE
    SBRS  B_newVlt              ;2a
    RJMP  VLTsegE

; GainV_H\L= Vlt2bcd = 5856 = 0x16E0, @0x0014 [AddrGVh]

; DECvoltH\L = r20:r19 = avgVoltH\L * voltG_H\L / 256
    LDS   r17, avgVoltH         ;2a, get average voltage
    LDS   r16, avgVoltL         ;2a
    LDS   r14, voltG_H          ;2a, as 4988
    LDS   r13, voltG_L          ;2a [10a]
; r21:r20:r19:r18 = r17:r16 * r14:r13
    RCALL M_16x16               ;+23a [10a+23a=33a]

; mode 12V
    LDI   r16, 0xFF             ;1a             
    LDI   r17, 0xFF             ;1a,  r17:r16 = 0xFFFF/1 -1
    TST   r21                   ;1a
;if r21>0, volt too big, set r19=r20=0xFF 
    BRNE  VLTdec1               ;1a

; <no comment if Simu_1>
    RJMP  VLTdec2

/* <comment if Simu_1>
#ifndef MODE24V
; 12V mode
    RJMP  VLTdec2
#endif ; no MODE24V

#ifdef MODE24V
    LDI   r21, 0x80             ; r20:r19 = 0xFFFF/2
    LDI   r16, 0xFF
    LDI   r17, 0x7F             ; r17:r16 = 0xFFFF/2 -1
#endif ; MODE24V
#ifdef MODE48V
    LDI   r21, 0x40             ;1a, r20:r19 = 0xFFFF/4
    LDI   r16, 0xFF             ;1a
    LDI   r17, 0x3F             ;1a, r17:r16 = 0xFFFF/4 -1
#endif ; MODE48V
*/ ; <comment if Simu_1>

    CP    r20, r21              ;1a
    BRLO  VLTdec2               ;1a

VLTdec1:
    MOV   r19, r16              ;1a
    MOV   r20, r17              ;1a

VLTdec2:
    STS   DECvoltH, r20         ;2a, 00.000
    STS   DECvoltL, r19         ;2a

VLTsegE:
    RJMP  END_act               ;2a +17a [33a+17a=50a] of SMPL001

;--------------------------------------
;SMPL002: avgMainH\L to decMainH\L  ***
;--------------------------------------

MVI2dec:
    SBRS  B_doAvgM              ;2a
    RJMP  MVIdecE

; r18:r16 = r1:r0 + sumMaintU\H\L
    LDS   r16, sumMainL         ;2a
    LDS   r17, sumMainH         ;2a
    LDS   r18, sumMainU         ;2a

; clear sumMaintU\H\L
    STS   sumMainL, zero        ;2a
    STS   sumMainH, zero        ;2a
    STS   sumMainU, zero        ;2a

; r18:r17 = r18:r16 /64 
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a

;/* ; < no comment if Simu_1> /16
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
    LSL   r16                   ;1a
    ROL   r17                   ;1a
    ROL   r18                   ;1a
;*/ ; < no comment if Simu_1>

; r18:r17 = r18:r17 * 7282 / 256/256 [/9]    
    MOV   r13, r17              ;1a
    MOV   r14, r18              ;1a
    LDI   r16,  low(7282)       ;1a
    LDI   r17, high(7282)       ;1a [24a]

; r21:r20:r19:r18 = r17:r16 * r14:r13
; r21:r20 = [sumMainU\H\L/64] / 9
    RCALL M_16x16               ;+23a [24a+23a=47a] 

; save final average voltage   [ avgVoltH\L , reference 0 ]
    STS   avgMainL, r20         ;2a
    STS   avgMainH, r21         ;2a

    MOV   r17, r21              ;1a
    MOV   r16, r20              ;1a
    LDS   r14, mainG_H          ;2a
    LDS   r13, mainG_L          ;2a +11a [47a+11a=58a]
; r21:r20:r19:r18 = r17:r16 * r14:r13
    RCALL M_16x16               ;+23a [58a+23a=81a]
; DECmaintH\L = r20:r19 = avgmaintH\L * mainG_H\L / 256

; /100 == *655/256/256
    LDI   r16,  low(655)        ;1a
    LDI   r17, high(655)        ;1a
    MOV   r13, r19              ;1a
    MOV   r14, r20              ;1a +4a [81a+4a=85a]

; multiplicand: r17:r16
; multiplier  : r14:r13
; result out  : r21(S), r20(U), r19(H), r18(L)
    RCALL M_16x16               ;+23a [85a+23a=108a]
; r21:r20= mains voltage, as 220 
; r21 should be zero (max Volt = 255)

    TST   r21                   ;1a
    BRNE  MVIdec1               ;1a

    ROL   r19                   ;1a, for rounding r20
    ADC   r20, zero             ;1a
    BRCC  MVIdec2               ;2a

MVIdec1:
    LDI   r20, 255
       
MVIdec2:
    STS   DECmain, r20          ;2a

MVIdecE:
    RJMP  END_act               ;2a +10a [108a+10a=118a] of SMPL002

;-----------------------------------
;SMPL003: decCurrH\L to DigtA2:1 ***
;-----------------------------------

CUR2seg:
; if not B_newAmp, goto CURsegE
    SBRS  B_newAmp              ;2a
    RJMP  CURsegE

    LDI   ZH, high(DIGTtbl*2)   ;1a, table must start at 0x---0

    LDI   YH, high(DigtA1)      ;1a
    LDI   YL,  low(DigtA1)      ;1a, destination

; r20:r16 = DEC2BCD(decCurrH\L)
    LDS   r16, decCurrL         ;2a, get absolute average current
    LDS   r17, decCurrH         ;2a [9a]

;  input: R17, R16 = 16 bit; value 0 to 65535
; output: R20, R19, R18, R17, R16 = 5 digits (ASCII)
; 60909 [+175a+7a=182a]
;  0909 [+145a+7a=152a]
;    09 [+100a+7a=107a]
;current: R19:R18 or R18:R17 [adjust]
    RCALL DEC2BCD               ;+152a [9a+152a=161a]

    SBRS  B_adjMod              ;2a +2a [161a+2a=163a]
    RJMP  CUR2sg1

; adjust mode
; r18:r16 (BCD) to DigtA3:1  [as 0.00]
    LDI   r20, 3                ; for loop
    LDI   XH, high(16)
    LDI   XL,  low(16)

CUR2sgT:
    LD    ZL, X+
    LPM   r21, Z                ; load Indirect as 7seg from table
    ST    Y+, r21               ; re-save as 7seg
    DEC   r20
    BRNE  CUR2sgT

    LDS   r16, DigtA3           ; [as 0.00], no sign
    SBR   r16, Seg_dot
    STS   DigtA3, r16
    RJMP  CUR2sgR

;===

; run mode
CUR2sg1:
    CLT                         ;1a
    TST   r19                   ;1a
    BRNE  CUR2sgC               ;2a +4a [163a+4a=167a]

    SET

CUR2sgC:
; decCurrH\L > 999 OR decCurrH\L < 1000
; r19:r18 (BCD) to DigtA2:1  [as -00 or -0.0 , digit3 for sign]
    LDI   r20, 2                ;1a, for loop
    LDI   XH, high(18)          ;1a
    LDI   XL,  low(18)          ;1a

    BRTC  CUR2sgL               ;1a

; decCurrH\L < 1000
    LDI   XH, high(17)          ;1a
    LDI   XL,  low(17)          ;1a +6a [167a+6a=173a]

CUR2sgL:
; decCurrH\L > 999 OR decCurrH\L < 1000
    LD    ZL, X+                ;2a
    LPM   r21, Z                ;3a, load Indirect as 7seg from table
    ST    Y+, r21               ;2a, re-save as 7seg
    DEC   r20                   ;1a
    BRNE  CUR2sgL               ;2a +19a [173a+19a=192a]

    BRTC  CUR2sg_               ;2a +2a [192a+2a=194a]

; decCurrH\L < 1000
    LDS   r16, DigtA2
    SBR   r16, Seg_dot
    STS   DigtA2, r16
    RJMP  CUR2sgB

;===

CUR2sg_:
; decCurrH\L > 999
    LDS   r17, DigtA2           ;2a
    CPI   r17, SEGS_0_          ;1a, -00 or -_0 
    BRNE  CUR2sgB               ;1a

; decCurrH\L > 999
; if 10's of current = 0, set 3rd digit as blank [Digt_2]
    LDI   r16, SEGSblk          ;1a
    STS   DigtA2, r16           ;2a, -_0 

CUR2sgB:
; if positive current, set 3rd digit as blank [Digt_3]
    LDI   r16, SEGSblk          ;1a
    SBRC  B_ampNeg              ;1a
    LDI   r16, SEGS_md          ;1a

CUR2sgE:
    STS   DigtA3, r16           ;2a, set 3rd digit as minus or blank

CUR2sgR:
    RJMP  END_act               ;2a, +2a [194a+15a=209a] of SMPL003

;-----------------------------------
;SMPL004: DECvoltH\L to DigtV3:1 ***
;-----------------------------------

VLT2seg:
; if not B_newVlt [display] , goto VLTsegE
    SBRS  B_newVlt              ;2a
    RJMP  VLTsegE

    LDI   ZH, high(DIGTtbl*2)   ;1a, table must start at 0x---0

    LDI   YH, high(DigtV1)      ;1a
    LDI   YL,  low(DigtV1)      ;1a, destination

    LDS   r16, DECvoltL         ;2a
    LDS   r17, DECvoltH         ;2a

/* <comment if Simu_1>
#ifdef MODE24V
; *2
    LSL    r16                  ;1a *2
    ROL    r17                  ;1a
#endif ; MODE24V
#ifdef MODE48V
; *2
    LSL    r16                  ;1a *2
    ROL    r17                  ;1a [13a]
#endif ; MODE48V
*/ ; <comment if Simu_1>

; 60909 [+175a+7a=182a]
;  0909 [+145a+7a=152a]
;    09 [+100a+7a=107a]
;  input: R17, R16 = 16 bit; value 0 to 65535
; output: R20, R19, R18, R17, R16 = 5 digits (ASCII)
;voltage: R20:R18
    RCALL DEC2BCD               ;+182a [13a+182a=195a]

    SBRS  B_adjMod              ;2a +2a [195a+2a=197a]
    RJMP  VLT2sg1

; adjust mode
; r19:r17 (BCD) to DigtV3:1  [as 0.00]
    LDI   r20, 3                ; for loop
    LDI   XH, high(17)
    LDI   XL,  low(17)

VLT2sgT:
    LD    ZL, X+
    LPM   r21, Z                ; load Indirect as 7seg from table
    ST    Y+, r21               ; re-save as 7seg
    DEC   r20
    BRNE  VLT2sgT

    LDS   r16, DigtV3           ; [as 0.00], no sign
    SBR   r16, Seg_dot
    STS   DigtV3, r16
    RJMP  VLT2sgR

;===

VLT2sg1:
; rounding first DEC digit
    CPI   r16, 5                ;1a
    BRLO  VLT2sgC               ;1a

    INC   r17                   ;1a
    CPI   r17, 10               ;1a
    BRLO  VLT2sgC               ;1a

    CLR   r17                   ;1a, reset to 0
    INC   r18                   ;1a
    CPI   r18, 10               ;1a
    BRLO  VLT2sgC               ;1a

    CLR   r18                   ;1a, reset to 0
    INC   r19                   ;1a
    CPI   r19, 10               ;1a
    BRLO  VLT2sgC               ;1a

    CLR   r19                   ;1a, reset to 0
    INC   r20                   ;1a
    CPI   r20, 10               ;1a
    BRLO  VLT2sgC               ;1a

    LDI   r20, 9                ;1a, 99.99
    LDI   r19, 9                ;1a
    LDI   r18, 9                ;1a
    LDI   r17, 9                ;1a

VLT2sgC:
; r20:r18 (BCD) to DigtV3:1  [as 00.0]
    LDI   r16, 3                ;1a for loop
    LDI   XH, high(18)          ;1a
    LDI   XL,  low(18)          ;1a +24a [197a+24a=221a]

;    LDI   YH, high(DigtV0)
;    LDI   YL,  low(DigtV0)      ; destination

VLT2sgL:
    LD    ZL, X+                ;2a
    LPM   r21, Z                ;3a, load Indirect as 7seg from table
    ST    Y+, r21               ;2a, re-save as 7seg
    DEC   r16                   ;1a
    BRNE  VLT2sgL               ;2a +29a [221a+29a=250a]

    LDS   r16, DigtV2           ;2a
    SBR   r16, Seg_dot          ;1a
    STS   DigtV2, r16           ;2a

VLT2sgR:
    RJMP  END_act               ;2a +7a [250a+7a=257a] of SMPL004

;--------------------------------
;SMPL005: DECmain to DigtM3:1 ***
;--------------------------------

MVI2seg:
    SBRS  B_doAvgM              ;2a
    RJMP  MVIsegE

    CBR   F_doAvgM              ;1a

    SBRS  B_adjMod              ;2a
    RJMP  MVIsegE

    LDI   ZH, high(DIGTtbl*2)   ;1a, table must start at 0x---0

    LDI   YH, high(DigtM1)      ;1a
    LDI   YL,  low(DigtM1)      ;1a, destination

    LDS   r16, DECmain          ;2a
    CLR   r17                   ;2a  [12a]

; 60909 [+175a+7a=182a]
;  0909 [+145a+7a=152a]
;    09 [+100a+7a=107a]
;  input: R17, R16 = 16 bit; value 0 to 65535
; output: R20, R19, R18, R17, R16 = 5 digits (ASCII)
;voltage: R20:R18
    RCALL DEC2BCD               ;+152a [12a+152a=164a]

; r19:r17 (BCD) to DigtV3:1  [as 0.00]
    LDI   r20, 3                ;1a, for loop
    LDI   XH, high(16)          ;1a
    LDI   XL,  low(16)          ;1a +3a [164a+3a=167a]

MVI2sgL:
    LD    ZL, X+                ;2a
    LPM   r21, Z                ;3a, load Indirect as 7seg from table
    ST    Y+, r21               ;2a, re-save as 7seg
    DEC   r20                   ;1a
    BRNE  MVI2sgL               ;2a +29a [167a+29a=196a]

MVIsegE:
    RJMP  END_act               ;2a +2a [196a+2a=198a] of SMPL005

;-------------------------------------------------------------
;SMPL006: Check high voltage and current to MOSFET control ***
;-------------------------------------------------------------

CHK_max:
    SBRS  B_newAmp
    RJMP  CHKmaxR

    LDI   ZH, high(PWM_max)     ; at 0x??00
    LDS   ZL, DECmain
    LSL   ZL
    ROL   ZH

    LPM   r16, Z+               ;3a
    LPM   r17, Z+               ;3a
    STS   PWM_maxL, r16
    STS   PWM_maxH, r17

CHKvolt:
; assume DECvoltH\L < v_hiDecH\L
    CBR   F_voltHi

; r17:r16 = DECvoltH\L
    LDS   r16, DECvoltL
    LDS   r17, DECvoltH
    LDS   r13, v_hiDecL
    LDS   r14, v_hiDecH
    CP    r16, r14
    CPC   r17, r13
    BRLO  CHKcurr

; DECvoltH\L >= v_hiDecH\L
    SBR   F_voltHi

    LDS   r18, PWM_L
    LDS   r19, PWM_H
    SUBI  r18,  low(2)
    SBCI  r19, high(2)
CHKmxLo:
    TST   r19
    BRNE  CHKmaxE

    CPI   r18, 24               ; 24=3us/0.125us
    BRSH  CHKmaxE

    LDI   r18, 24
    RJMP  CHKmaxE

CHKcurr:
; assume DECcurrH\L < c_hiDecH\L
    CBR   F_currHi

; r17:r16 = DECcurrtH\L
    LDS   r16, DECcurrL
    LDS   r17, DECcurrH
    LDS   r13, c_hiDecL
    LDS   r14, c_hiDecH
    CP    r16, r14
    CPC   r17, r13
    BRLO  CHKcMin

; DECcurrH\L >= c_hiDecH\L
    SBR   F_currHi

    LDS   r18, PWM_L
    LDS   r19, PWM_H
    SUBI  r18,  low(2)
    SBCI  r19, high(2)
    RJMP  CHKmxLo

;===

CHKcMin:
; r17:r16 = DECcurrH\L + 2
    SUBI  r16,  low(-2)
    SBCI  r17, high(-2)
    CP    r16, r14
    CPC   r17, r13
    BRSH  CHKmaxE

; r19:r18 = PWM_H\L + 1
    LDS   r18, PWM_L
    LDS   r19, PWM_H
    SUBI  r18,  low(-1)
    SBCI  r19, high(-1)

    LDS   r16, PWM_maxL
    LDS   r17, PWM_maxH
    CP    r18, r16
    CPC   r19, r17
    BRLO  CHKmaxE

    LDS   r18, PWM_maxL
    LDS   r19, PWM_maxH
CHKmaxE:
    STS   PWM_L, r18
    STS   PWM_H, r19

    MOV   r16, r18
    OR    r16, r19
    BREQ  STP_pwm

    TST   r19
    BRNE  CHKmaxC

    CPI   r18, 24
    BRSH  CHKmaxC

    LDI   r18, 24
CHKmaxC:
    STS   PWM_L, r18
    STS   PWM_H, r19
    RJMP  RUN_pwm

STP_pwm:
    SBIS  S_pwmMod
    RJMP  CHKmaxR

    CBI   S_pwmMod
    LDI   r16, TCCR1Astp        ; 0b00000010 [run=0b10000010]
    OUT   TCCR1A, r16
    LDI   r16, TCCR1Bstp        ; 0b00011000 [run=0b00011001]
    OUT   TCCR1B, r16
    RJMP  CHKmaxR

RUN_pwm:
    OUT   OCR1AH, r18          ;1a
    OUT   OCR1AL, r19          ;1a

    SBIC  S_pwmMod
    RJMP  CHKmaxR

    SBI   S_pwmMod
    LDI   r16, TCCR1Brun        ; 0b00011001 [stp=0b00011000]
    OUT   TCCR1B, r16
    LDI   r16, TCCR1Arun        ; 0b10000010 [stp=0b00000010]
    OUT   TCCR1A, r16

    LDI   r17, high(PWM_top)    ; 364
    OUT   ICR1H, r17
    LDI   r16,  low(PWM_top)
    OUT   ICR1L, r16

CHKmaxR:
    RJMP  END_act               ; of SMPL003

;----------------------------------------------------------
;SMPL007: set zero current level at boot if adjust mode ***
;----------------------------------------------------------

SETzero:
    SBRS  B_newAmp
    RJMP  SETzroR

    CBR   F_newAmp

    SBIC  EECR, EEWE
    RJMP  SETzroR

    SBRC  B_currHi
    RJMP  SETzroR

    SBRS  B_adjMod
    RJMP  SETzroR

    SBIC  S_iniZro
    RJMP  SETzroR

    LDS   r16, dlyZero
    INC   r16
    STS   dlyZero, r16
    CPI   r16, 4
    BRLO  SETzroR

    CLR   dspOff
    SBR   F_dspOff

    LDS   r20, avgCzroL
    LDS   r21, avgCzroH
    SUBI  r20,  low(511)
    SBCI  r21, high(511)
    STS   ZroDifL, r20
    STS   ZroDifH, r21

; prepare for saving
    LDI   r18, ADDRzro
    STS   EEaddr_L, r18

; S_zroSav=1 [to save ZroDifH\L in EE]
    SBI   S_zroSav

; S_iniZro=1 [no more zero setting]
    SBI   S_iniZro

SETzroR:
    RJMP  END_act               ; of SMPL004

;-------------------------------------------------------------
;SMPL008: User setting of voltage maximum by UP_keys [PC5] ***
;-------------------------------------------------------------
; USRoutH, to exit  prog mode [10s]
; USRprgH, to enter prog mode [ 4s]
; USRrptH, to repeat update   [640ms]

KEYhigh:
; increment TcountrH\L
    LDS   r26, TcountrL
    LDS   r27, TcountrH
    ADIW  r26, 1
    STS   TcountrL, r26
    STS   TcountrH, r27

    SBRC  B_adjMod
    RJMP  KEYhiRt

    SBIC  EECR, EEWE
    RJMP  KEYhiRt

    SBRC  B_kyLoOn
    RJMP  KEYhiRt

    SBRS  B_usrChi
    RJMP  KEYhiCt

    IN    r16, PINC
    ORI   r16, TWOkeys          ; 0b11001111

    SBIS  S_Do_Rst
    RJMP  KEYhiC_

    CPI   r16, NO_keys          ; 0b11111111
    BRNE  KEYhiRt

    RJMP  RESET

KEYhiC_:
; sense UP_keys, when released RESET
    CPI   r16, UP_keys          ; 0b11011111
    BRNE  KEYhiRt

    SBI   S_Do_Rst
    RJMP  KEYhiRt

KEYhiCt:
; sense UP_keys, on or off
    IN    r16, PINC
    ORI   r16, UP_keys          ; 0b11011111
    CPI   r16, NO_keys          ; 0b11111111
    BRNE  KEYhiOn

; key is off
KEYhiOf:
    SBRS  B_kyHiOn
    RJMP  HIoffof

; on-off   [ key was on ]
; on-off , prog or noProg
HIonOff:
    CBR   F_kyHiOn              ; signal key is off
    RJMP  HIreset               ; TcountrH\L

; off-off   [ key was off ]
HIoffOf:
; off-off , noProg
    SBRS  B_usrVhi
    RJMP  HIreset

; off-off , prog
    LDS   r16, TcountrH
    CPI   r16, USRoutH          ; 10 sec
    BRLO  KEYhiRt

    SBI   S_vHiSav
    CBR   F_usrVhi
    CBR   F_usrChi

HIreset:
    CLR   r16
    STS   TcountrL, r16
    STS   TcountrH, r16
KEYhiRt:
    RJMP  END_act               ; of SMPL007

;===

; key is on
KEYhiOn:
    SBRC  B_kyHiOn
    RJMP  HI_onOn

; off-on   [ key was off ]
HIoffOn:
    SBR   F_kyHiOn              ; signal key is on
; off-on , prog
    SBRC  B_usrVhi
    RJMP  KEYhiRt               ; return if prog

; off-on , no-prog
HInrmOf:
    SBR   F_pass_1
    RJMP  HIreset

; on-on   [ key was on ]
HI_onOn:
    SBRC  B_usrVhi
    RJMP  HIprgOn

; on-on , noProg
HInrmOn:                        ; reach here even if no press
    LDS   r16, TcountrH
    CPI   r16, USRprgH          ; 4 sec
    BRLO  KEYhiRt

    CBR   F_usrChi
    SBR   F_usrVhi

    LDS   r14, v_hiDecB         ; 0x91   = 145
    LDS   r17, v_hiDecH         ; 0x38A4 = 14500
    LDS   r16, v_hiDecL

    SBR   F_dspOff
    CLR   dspOff

HIbcdCt:
    STS   TmpDecH, r17
    STS   TmpDecL, r16
    STS   TmpDecB, r14

    RCALL VlmtSeg
    RJMP  HIreset

; on-on , prog
HIprgOn:
; wait return of display
    SBRC  B_dspOff
    RJMP  HIreset

    SBRC  B_pass_1
    RJMP  HIpass1

    LDS   r16, TcountrH
    CPI   r16, USRrptH          ; 0.639 sec
    BRLO  KEYhiRt

    LDS   r14, TmpDecB
    LDS   r17, TmpDecH
    LDS   r16, TmpDecL

    CPI   r16,  low(VltHiW)
    LDI   r18, high(VltHiW); for 16V0, highest voltage limit
    CPC   r17, r18
    BRLO  HIprgCt

    LDI   r16, VltLoB-1         ; for 13V5, lowest voltage limit
    MOV   r14, r16
    LDI   r16,  low(VltLoW-100)
    LDI   r17, high(VltLoW-100)

HIprgCt:
    SUBI  r16,  low(-100)
    SBCI  r17, high(-100)
    INC   r14
    RJMP  HIbcdCt

HIpass1:
    SBR   F_dspOff
    CLR   dspOff

    CBR   F_pass_1
    RJMP  HIreset

;-------------------------------------------------------------
;SMPL009: User setting of current maximum by DW_keys [PC4] ***
;-------------------------------------------------------------
; USRoutH, to exit  prog mode [10s]
; USRprgH, to enter prog mode [ 4s]
; USRrptH, to repeat update   [640ms]

KEY_low:
; increment TcountrH\L
    LDS   r26, TcountrL
    LDS   r27, TcountrH
    ADIW  r26, 1
    STS   TcountrL, r26
    STS   TcountrH, r27

    SBRC  B_adjMod
    RJMP  KEYloRt

    SBIC  EECR, EEWE
    RJMP  KEYloRt

    SBRC  B_kyHiOn
    RJMP  KEYloRt

    SBRS  B_usrVhi
    RJMP  KEYloCt

    IN    r16, PINC
    ORI   r16, TWOkeys          ; 0b11001111

    SBIS  S_Do_Rst
    RJMP  KEYloC_

    CPI   r16, NO_keys          ; 0b11111111
    BRNE  KEYloRt

    RJMP  RESET

KEYloC_:
; sense DW_keys, when released RESET
    CPI   r16, DW_keys          ; 0b11101111
    BRNE  KEYloRt

    SBI   S_Do_Rst
    RJMP  KEYloRt

KEYloCt:
; sense DW_keys, on or off
    IN    r16, PINC
    ORI   r16, DW_keys          ; 0b11101111
    CPI   r16, NO_keys          ; 0b11111111
    BRNE  KEYloOn

; key is off
KEYloOf:
    SBRS  B_kyLoOn
    RJMP  LOoffof

; on-off   [ key was on ]
; on-off , prog or noProg
LOonOff:
    CBR   F_kyLoOn              ; signal key is off
    RJMP  LOreset

; off-off   [ key was off ]
LOoffOf:
; off-off , noProg
    SBRS  B_usrChi
    RJMP  LOreset

; off-off , prog
    LDS   r16, TcountrH
    CPI   r16, USRoutH          ; 10 sec
    BRLO  KEYloRt

    SBI   S_cHiSav
    CBR   F_usrVhi
    CBR   F_usrChi

LOreset:
    CLR   r16
    STS   TcountrL, r16
    STS   TcountrH, r16

KEYloRt:
    RJMP  END_act               ; of SMPL008

;===

; key is on
KEYloOn:
    SBRC  B_kyLoOn
    RJMP  LO_onOn

; off-on   [ key was off ]
LOoffOn:
    SBR   F_kyLoOn              ; signal key is on
; off-on , prog
    SBRC  B_usrChi
    RJMP  KEYloRt               ; return if prog

; off-on , no-prog
LOnrmOf:
    SBR   F_pass_1
    RJMP  LOreset

; on-on   [ key was on ]
LO_onOn:
    SBRC  B_usrChi
    RJMP  LOprgOn

; on-on , noProg
LOnrmOn:                        ; reach here even if no press
    LDS   r16, TcountrH
    CPI   r16, USRprgH          ; 4 sec
    BRLO  KEYloRt

    CBR   F_usrVhi
    SBR   F_usrChi

    LDS   r14, c_hiDecB
    LDS   r17, c_hiDecH         ; 0x30D4 = 14500?
    LDS   r16, c_hiDecL

    SBR   F_dspOff
    CLR   dspOff

LObcdCt:
    STS   TmpDecH, r17
    STS   TmpDecL, r16
    STS   TmpDecB, r14

    RCALL VlmtSeg
    RJMP  LOreset

; on-on , prog
LOprgOn:
; wait return of display
    SBRC  B_dspOff
    RJMP  LOreset

    SBRC  B_pass_1
    RJMP  LOpass1

    LDS   r16, TcountrH
    CPI   r16, USRrptH          ; 0.639 sec
    BRLO  KEYloRt

    LDS   r14, TmpDecB
    LDS   r17, TmpDecH
    LDS   r16, TmpDecL

    CPI   r16,  low(AmpHiW)
    LDI   r18, high(AmpHiW)     ; for 25A, highest current limit
    CPC   r17, r18
    BRLO  LOprgCt

    LDI   r16, AmpLoB-1         ; for 5A, lowest current limit
    MOV   r14, r16
    LDI   r16,  low(AmpLoW-100)
    LDI   r17, high(AmpLoW-100)

LOprgCt:
    SUBI  r16,  low(-100)
    SBCI  r17, high(-100)
    INC   r14
    RJMP  LObcdCt

;===

LOpass1:
    SBR   F_dspOff
    CLR   dspOff

    CBR   F_pass_1
    RJMP  LOreset

;-------------------------------------------------------------------
;SMPL010: if PC4 or PC5 shorted, signal a setting [Gi, Gv or Gm] ***
;-------------------------------------------------------------------

KEYSadj:
    SBRS  B_adjMod
    RJMP  ADJprsR

    SBRC  B_dspOff
    RJMP  ADJprsR

    SBIC  EECR, EEWE
    RJMP  ADJprsR

    SBIC  S_Gi_Sav
    RJMP  ADJprsR

    SBIC  S_Gv_Sav
    RJMP  ADJprsR

    SBIC  S_Gm_Sav
    RJMP  ADJprsR

    SBRC  B_keyDly
    RJMP  KEYS_rd               ; delay of KEYsavH\L active

; keyDlyH\L for 2s
    LDI   r16, KEYsavL
    MOV   keyDlyL, r16
    LDI   r16, KEYsavH
    MOV   keyDlyH, r16
    SBR   F_keyDly

KEYS_rd:
; check low of PC5[up] or PC4[dw]
    IN    r16, PINC
    ORI   r16, TWOkeys          ; 0b11001111
    CPI   r16, NO_keys          ; 0b11111111
    BREQ  KEYSend               ; do nothing if both keys are off

    CPI   r16, TWOkeys          ; 0b11001111
    BREQ  KEYSend               ; do nothing if both keys are on

    SBRC  B_pass_1
    RJMP  KEYScnt

    RCALL SAVtemp
KEYScnt:
    DEC   keyDlyL
    BRNE  ADJprsR

    DEC   keyDlyH
    BRNE  ADJprsR

    LDS   r16, DECmain
    CPI   r16, 180
    BRLO  KEYSnrm

    SBI   S_Gm_Set
    RJMP  KYSprsE

KEYSnrm:
    SBI   S_Gv_Set
    SBRS  B_ampMod
    RJMP  KYSprsE

    SBI   S_Gi_Set
    CBI   S_Gv_Set

KYSprsE:
    SBR   F_dspOff
    CLR   dspOff

KEYSend:
    CBR   F_keyDly
    CBR   F_pass_1

ADJprsR:
    RJMP  END_act               ; [+10x] of SMPL009

;=== ===

SAVtemp:
    LDS   r16, avgVoltL
    LDS   r17, avgVoltH
    STS   avgVtmpL, r16
    STS   avgVtmpH, r17

    LDS   r16, avgCurrL
    LDS   r17, avgCurrH
    STS   avgCtmpL, r16
    STS   avgCtmpH, r17

    LDS   r16, avgMainL
    LDS   r17, avgMainH
    STS   avgMtmpL, r16
    STS   avgMtmpH, r17

    SBR   F_pass_1
    RET

;--------------------------------------------------
;SMPL012: set currG_H\L, voltG_H\L or mainG_H\L ***
;--------------------------------------------------

ADJ_set:
    SBRS  B_adjMod
    RJMP  ADJsetE

    SBIS  S_Gi_Set
    RJMP  IS_GvSt

    LDI   r18, high(CurAdjt)
    LDI   r17,  low(CurAdjt)
    CLR   r16
    LDS   r20, avgCtmpH
    LDS   r19, avgCtmpL

; dividend : r18:r17:r16
; divisor  : r20:r19
; remainder: r14:r13
; loopCount: r21(steps=25)
; result   : r2:r1:r0 , 414 cycles

; r1:r0 = CurAdjt * 256 / avgCurrH\L [call D24u16rd:]
    RCALL D24u16rd              ;429a

    MOV   r16, r0
    MOV   r17, r1

; 0x0EEA [3818] < currG_H\L < 0x123A [4666], 11.0A > Ibatt > 9.0A
; compare current gains
    CPI   r16,  low(For09A0)
    LDI   r18, high(For09A0)
    CPC   r17, r18
    BRLO  SETc_C2

SETc_C1:
; currG_H\L > 0x123A [4666], Ibatt > 9.0A
    RJMP  FTLer10

SETc_C2:
; compare current gains
    CPI   r16,  low(For11A0)
    LDI   r18, high(For11A0)
    CPC   r17, r18
    BRSH  SETc_C4

SETc_C3:
; currG_H\L < 0x0EEA [3818], Ibatt > 11.0A
    RJMP  FTLer11

SETc_C4:
; currC_H\L = r1:r0
    STS   currG_H, r1
    STS   currG_L, r0

; prepare for saving
    LDI   r18, ADDRc_h
    STS   EEaddr_L, r18

; S_Gi_Sav=1 [to save currG_H\L in EE]
    CBI   S_Gi_Set
    SBI   S_Gi_Sav
    RJMP  ADJsetE

;===

IS_GvSt:
    SBIS  S_Gv_Set
    RJMP  IS_GmSt
;    RJMP  ADJsetE

    LDI   r18, high(VltAdjt)
    LDI   r17,  low(VltAdjt)
    CLR   r16
    LDS   r20, avgVtmpH
    LDS   r19, avgVtmpL

; dividend : r18(dd_U), r17(dd_H) , r16(dd_L)
; divisor  : r20(dv_H) , r19(dv_L)
; remainder: r14(rmd_H), r13(rmd_L)
; loopCount: r21(steps=25)
; result   : r2(res_U),r1(res_H),r0(res_L) , 414 cycles

; r1:r0 = VltAdjt * 256 / avgVoltH\L [call D24u16rd:]
    RCALL D24u16rd              ;429a

    MOV  r17, r1
    MOV  r16, r0

; compare voltage gains
; 0x1269 [4713] < voltG_H\L < 0x1541 [5441], 12.5V > Vbatt > 11V
    CPI  r17, high(For11V0)
    BRLO SETv_C2

    BRNE SETv_C2

    CPI  r16, low(For11V0)
    BRLO SETv_C2

SETv_C1:
    RJMP FTLer12

SETv_C2:
; compare voltage gains
; 0x1269 [4713] < voltG_H\L < 0x1541 [5441], 12.5V > Vbatt > 11V
    CPI  r17, high(For12V5)+1
    BRSH SETv_C4

    CPI  r17, high(For12V5)
    BRNE SETv_C4

    CPI  r16, low(For12V5)+1
    BRSH SETv_C4

SETv_C3:
    RJMP FTLer13

SETv_C4:
; voltG_H\L = r1:r0
    STS   voltG_H, r1
    STS   voltG_L, r0

; prepare for saving
    LDI   r18, ADDRv_h
    STS   EEaddr_L, r18

; S_Gv_Sav=1 [to save voltG_H\L in EE]
    CBI   S_Gv_Set
    SBI   S_Gv_Sav
    RJMP  ADJsetE

;===

IS_GmSt:
    SBIS  S_Gm_Set
    RJMP  ADJsetE

    LDI   r18, high(MviAdjt)
    LDI   r17,  low(MviAdjt)
    CLR   r16
    LDS   r20, avgMtmpH
    LDS   r19, avgMtmpL

; dividend : r18(dd_U), r17(dd_H) , r16(dd_L)
; divisor  : r20(dv_H) , r19(dv_L)
; remainder: r14(rmd_H), r13(rmd_L)
; loopCount: r21(steps=25)
; result   : r2(res_U),r1(res_H),r0(res_L) , 414 cycles

; r1:r0 = VltAdjt * 256 / avgVoltH\L [call D24u16rd:]
    RCALL D24u16rd              ;429a

    STS   mainG_H, r1
    STS   mainG_L, r0

; prepare for saving
    LDI   r18, ADDRm_h
    STS   EEaddr_L, r18

; S_Gv_Sav=1 [to save voltG_H\L in EE]
    CBI   S_Gm_Set
    SBI   S_Gm_Sav

ADJsetE:
    RJMP  END_act               ; [+10x] of SMPL010

;------------------------------------
;SMPL013: set screen display mode ***
;------------------------------------

SCRNmod:
    SBRS  B_adjMod
    RJMP  SCRnrml

    LDS   r16, DECmain
    CPI   r16, 180
    BRLO  SCRNadj

    SBI   S_mviMod
    RJMP  SCRmodE

SCRNadj:
    CBI   S_mviMod
    
; assume SCNkeyIn is shorted
    SBR   F_vltMod
    CBR   F_ampMod

    SBIS  SCNkeyIn
    RJMP  SCRmodE

; SCNkeyIn open
    CBR   F_vltMod
    SBR   F_ampMod

    RJMP  SCRmodE

;=== ===

SCRnrml:
; if SCNkeyIn=low [PB0, pin14], no action
    SBIS  SCNkeyIn
    RJMP  SCRmodE

    LDS   r17, scrDlyH
    LDS   r16, scrDlyL
    SUBI  r16,  low(1)
    SBCI  r17, high(1)
    STS   scrDlyH, r17
    STS   scrDlyL, r16
    BRNE  SCRmodR

    LDI   r17, DLYscrH
    LDI   r16, DLYscrL
    STS   scrDlyH, r17
    STS   scrDlyL, r16

ISampSc:
    SBRS  B_ampMod
    RJMP  DOampSc

DOvltSc:
    SBR   F_vltMod
    CBR   F_ampMod
    RJMP  SCRmodR

DOampSc:
    CBR   F_vltMod
    SBR   F_ampMod
    RJMP  SCRmodR

SCRmodE:
    LDI   r16, 120              ; 200ms for key bouncing
    STS   scrDlyL, r16
    STS   scrDlyH, zero

SCRmodR:
    RJMP  END_act               ; of SMPL009

;-------------------------------------
;SMPL015: Save a byte without halt ***
;-------------------------------------
; save currG_H\L , voltG_H\L , TmpDecB, mainG_H\L

SAVEval:
    SBIC  EECR, EEWE
    RJMP  SVbytRt

    OUT   EEARH, zero

ISsavZr:
    SBIS  S_zroSav
    RJMP  ISsavGi

DOsavZr:
; r16 = EEaddr_L = ADDRzro
    LDS   r16, EEaddr_L

; if r16 != ADDRzro, goto Z_SavB2: [save low]
    CPI   r16, ADDRzro
    BRNE  Z_SavB2

Z_SavB1:
; save r17= ZroDifH , first pass
; EEaddr_L = r16 + 1 [for the next pass]
    INC   r16
    STS   EEaddr_L, r16

; restore ADDRzro
    DEC   r16

; save r17 = ZroDifH , first pass
    LDS   r17, ZroDifH
    RJMP  Z_SavCt

Z_SavB2:
; save r17= ZroDifL , second pass
    LDS   r17, ZroDifL

; S_Gi_Sav=0 [second byte is saved]
    CBI   S_zroSav

Z_SavCt:
    RCALL SAVEbyt
    RJMP  SVbytRt

;=== ===

ISsavGi:
    SBIS  S_Gi_Sav
    RJMP  ISsavGv

DOsavGi:
; r16 = EEaddr_L = ADDRc_h
    LDS   r16, EEaddr_L

; if r16 != ADDRc_h, goto C_SavB2: [save low]
    CPI   r16, ADDRc_h
    BRNE  C_SavB2

C_SavB1:
; save r17= currG_H , first pass
; EEaddr_L = r16 + 1 [for the next pass]
    INC   r16
    STS   EEaddr_L, r16

; restore ADDRc_h
    DEC   r16

; save r17 = currG_H , first pass
    LDS   r17, currG_H
    RJMP  C_SavCt

C_SavB2:
; save r17= currG_L , second pass
    LDS   r17, currG_L

C_SavCt:
    RCALL SAVEbyt

; S_Gi_Sav=0 [second byte is saved]
    CBI   S_Gi_Sav
    RJMP  SVbytRt

;=== ===

ISsavGv:
    SBIS  S_Gv_Sav
    RJMP  ISsavGm
;    RJMP  ISsvHiV

DOsavGv:
; r16 = EEaddr_L = ADDRv_h
    LDS   r16, EEaddr_L

; if r16 != ADDRv_h, goto V_SavB2: [save low]
    CPI   r16, ADDRv_h
    BRNE  V_SavB2

V_SavB1:
; save r17= voltG_H, first pass
; EEaddr_L = r16 + 1 [for the next pass]
    INC   r16
    STS   EEaddr_L, r16

; restore ADDRv_h
    DEC   r16

; save r17 = voltG_H , first pass
    LDS   r17, voltG_H
    RJMP  V_SavCt

V_SavB2:
; save r17= voltG_L , second pass
    LDS   r17, voltG_L

V_SavCt:
    RCALL SAVEbyt

; S_Gv_Sav=0 [second byte is saved]
    CBI   S_Gv_Sav
    RJMP  SVbytRt

;=== ===

ISsavGm:
    SBIS  S_Gv_Sav
    RJMP  ISsvHiV

DOsavGm:
; r16 = EEaddr_L = ADDRv_h
    LDS   r16, EEaddr_L

; if r16 != ADDRv_h, goto V_SavB2: [save low]
    CPI   r16, ADDRm_h
    BRNE  M_SavB2

M_SavB1:
; save r17= mainG_H, first pass
; EEaddr_L = r16 + 1 [for the next pass]
    INC   r16
    STS   EEaddr_L, r16

; restore ADDRv_h
    DEC   r16

; save r17 = mainG_H , first pass
    LDS   r17, mainG_H
    RJMP  M_SavCt

M_SavB2:
; save r17= mainG_L , second pass
    LDS   r17, mainG_L

M_SavCt:
    RCALL SAVEbyt

; S_Gm_Sav=0 [second byte is saved]
    CBI   S_Gm_Sav
    RJMP  SVbytRt

;=== ===

ISsvHiV:
    SBIS  S_vHiSav
    RJMP  ISsvHiC

DOsavHi:
; r16 = ADDRvHi
    LDI   r16, ADDRvHi

; save r17 = TmpDecB
    LDS   r17, TmpDecB
    CBI   S_vHiSav
    RCALL SAVEbyt               ; save and reboot

    RJMP  EE2wait

;=== ===

ISsvHiC:
    SBIS  S_cHiSav
    RJMP  SVbytRt

; r16 = ADDRcHi
    LDI   r16, ADDRcHi

; save r17 = TmpDecB
    LDS   r17, TmpDecB
    CBI   S_cHiSav
    RCALL SAVEbyt               ; save and reboot

EE2wait:
    SBIC  EECR, EEWE            ; wait to end previous saving
    RJMP  EE2wait

    RJMP  RESET

;===

SVbytRt:
    RJMP  END_act               ; of SMPL014

.;=== ===

SAVEbyt:
    OUT   EEARL, r16
    OUT   EEDR, r17
    CLI                         ; disable interrupts during timed sequence
    SBI   EECR, EEMWE           ; enable EEPROM write
    SBI   EECR, EEWE            ; start EEPROM write
    SEI                         ; re-enable interrupts
    RET

;====================================================================
;====================================================================

;---------------------------------------------------------
;SMPL011: Show user high volt, battery current and voltage ***
;SMPL023:   or mains voltage in adjust mode
;---------------------------------------------------------

SHWdspl:
    MOV   r16, digtN
    CPI   r16, 2                ; end of digit_2
    BREQ  ISmainV

    RJMP  MODdspE

ISmainV:
    SBIS  S_mviMod
    RJMP  ISusrHi

DOmainV:
    LDS   r16, DigtM1
    STS   Digt_1, r16
    LDS   r16, DigtM2
    STS   Digt_2, r16
    LDS   r16, DigtM3
    STS   Digt_3, r16

    RJMP  MODdspE

ISusrHi:
    SBRS  B_usrVhi
    RJMP  ISusrCh

DOusrHi:
    LDS   r16, DgtVh1
    STS   Digt_1, r16
    LDS   r16, DgtVh2
    STS   Digt_2, r16
    LDS   r16, DgtVh3
    STS   Digt_3, r16

    RJMP  MODdspE

ISusrCh:
    SBRS  B_usrChi
    RJMP  ISampMd

DOusrCh:
    LDS   r16, DgtCh1
    STS   Digt_1, r16
    LDS   r16, DgtCh2
    STS   Digt_2, r16
    LDS   r16, DgtCh3
    STS   Digt_3, r16

    RJMP  MODdspE

ISampMd:
    SBRS  B_ampMod
    RJMP  ISvltMd

DOampMd:
    LDS   r16, DigtA1
    STS   Digt_1, r16
    LDS   r16, DigtA2
    STS   Digt_2, r16
    LDS   r16, DigtA3
    STS   Digt_3, r16

    RJMP  MODdspE

ISvltMd:
    SBRS  B_vltMod
    RJMP  DOerror

DOvltMd:
    LDS   r16, DigtV1
    STS   Digt_1, r16
    LDS   r16, DigtV2
    STS   Digt_2, r16
    LDS   r16, DigtV3
    STS   Digt_3, r16

    RJMP  MODdspE

DOerror:
;    LDS   r16, DgtEr0
;    STS   Digt_0, r16
    LDS   r16, DgtEr1
    STS   Digt_1, r16
    LDS   r16, DgtEr2
    STS   Digt_2, r16
    LDS   r16, DgtEr3
    STS   Digt_3, r16

;===

MODdspE:
SHWdCnt:
    INC   digtN
    MOV   r16, digtN            ; rate = 16*104us*4dgt = 6.656ms, 150Hz
;    CPI   r16, 0x04
    CPI   r16, 0x03
    BRLO  SHWdSkp

    CLR   r16                   ; as a counter from 0 to 2 only
    CLR   digtN
SHWdSkp:
    TST   r16
    BRNE  SHWdgt2

SHWdgt1:
    LDI   r17, DIGIT1on
    LDS   r13, Digt_1

    RJMP  SHWdEnd

SHWdgt2:
    DEC   r16
    BRNE  SHWdgt3

    LDI   r17, DIGIT2on
    LDS   r13, Digt_2

    RJMP  SHWdEnd

SHWdgt3:
    LDI   r17, DIGIT3on
    LDS   r13, Digt_3

SHWdEnd:
DOonOff:
    SBRS  B_currHi
    RJMP  DSPLoff

;/* <no comment if Simu_1>
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
;*/ ; <no comment if Simu_1>

    DEC   dspOff
    BRNE  DSPLoff_

    LDI   r16, X_dspOff
    EOR   R1flags, r16          ; flip F_dspOff

DSPLoff_:
    SBRS  B_dspOff
    RJMP  DSPL_on

    CLR   r13
    RJMP  DSPL_on

DSPLoff:
    SBRS  B_dspOff
    RJMP  DSPL_on

    CLR   r13

;/* <no comment if Simu_1>
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
    DEC   dspOff
;*/ ; <no comment if Simu_1>

    DEC   dspOff
    BRNE  DSPL_on

    CBR   F_dspOff              ; dspOff=0, offtime=256*16*104us=426ms

DSPL_on:
    IN    r16, DDRB             ; was PORTB
    ANDI  r16, DIGITSof         ; turn off all digit, 0b11100001
    OUT   DDRB, r16             ; was PORTB
    NOP
    OUT   DDRD, r13             ; set 7-seg outs, was PORTD
    OR    r16, r17              ; r16=0b11100011,r17=0b00000010[DIGIT1on]
    OUT   DDRB, r16             ; turn on digit, was PORTB

    SBRS  B_shwLmt
    RJMP  END_act               ; of SMPL015

    RET

;==========================================
;==========================================
;==========================================

END_act:
; MAIN_lp: [81a]
; ADC_ampr --> ADC_volt --> ADC_main ----> ADC_ampr... 
    IN    r16, ADMUX            ;1a
    CPI   r16, ADC_ampr         ;1a
    BRNE  ISadcVi               ;2a

DOadcVi:
; ADMUX= ADC_ampr, start ADC_volt
    LDI   r16, ADC_volt
    RJMP  DOadcEd

ISadcVi:
    CPI   r16, ADC_volt         ;2a
    BRNE  DOadcCi               ;1a

DOadcMi:
; ADMUX= ADC_volt, start ADC_main
    LDI   r16, ADC_main         ;1a
    RJMP  DOadcEd               ;2a

DOadcCi:
; ADMUX= ADC_main, start ADC_ampr
    LDI   r16, ADC_ampr

DOadcEd:
; ADMUX=L_2V56+ADC_Vx [2V56, right adjusted, ADCport]
    OUT   ADMUX, r16            ;1a

    CBI   TIMEcalb              ;2a, PC2, p25

    RJMP  MAIN_lp               ;2a +15a [81a+15a=96a] all common cycles

;===================

;-----------------------------------------------------
; *R* at boot show user's maximum  battery voltage ***
; ***           or user's maximum charging current ***
;-----------------------------------------------------

SHOWlmt:
    LDS   r17, v_hiDecH         ; 0x38A4 = 14500
    LDS   r16, v_hiDecL
    SBRC  B_usrVhi
    RJMP  SHOWvCt

    LDS   r17, c_hiDecH         ; 0x???? = 2000
    LDS   r16, c_hiDecL

SHOWvCt:
    RCALL VlmtSeg

    LDI   r16,  low(BOOTdly)    ; 1500*2ms = 3 sec
    MOV   keyDlyL, r16
    LDI   r16, high(BOOTdly)+1
    MOV   keyDlyH, r16

SHOWvLp:
    RCALL SHWdspl
    LDI   r17, 2                ; 2ms
    RCALL DLYmSec
    DEC   keyDlyL
    BRNE  SHOWvLp

    DEC   keyDlyH
    BRNE  SHOWvLp

    RET

;----------------------------------------------------
; *R* convert from BDC binary to 3 segment digits ***
;----------------------------------------------------
;  in: r17:r16
; out: DgtVh3:1 or DgtCh3:1

VlmtSeg:
    SBRS  B_usrVhi
    RJMP  A_bcdCt

/* <comment if Simu_1>
#ifdef MODE24V
    LSL    r16                  ; *2
    ROL    r17
#ifdef MODE48V
    LSL    r16                  ; *2
    ROL    r17
#endif ; MODE24V, MODE48V
#endif ; MODE24V
*/ ; <comment if Simu_1>

A_bcdCt:
; input: r17:r16
;output: R20, R19, R18, R17, R16 = 5 digits [BCD]
    RCALL DEC2BCD

; r20:r18 (BCD) to DgtVh3:0   [ as 00.0]
    LDI   r16, 3                ; for loop
    SBRS  B_usrVhi
    DEC   r16

    LDI   XH, high(18)          ; source
    LDI   XL,  low(18)

    LDI   YH, high(DgtVh1)
    LDI   YL,  low(DgtVh1)      ; destination

    SBRC  B_usrVhi
    RJMP  V_segCt

    LDI   YH, high(DgtCh1)
    LDI   YL,  low(DgtCh1)      ; destination

V_segCt:
; DgtVh3:1 (7seg) from r20:r18 (BCD)  [ table DIGTtbl ]
    LDI   ZH, high(DIGTtbl*2)   ; at 0x??00

V_seglp:
    LD    ZL, X+
    LPM   r21, Z                ; load Indirect as 7seg from table
    ST    Y+, r21               ; re-save as 7seg
    DEC   r16
    BRNE  V_seglp

    SBRS  B_usrVhi
    RJMP  VlmtCur

    LDS   r16, DgtVh2
    SBR   r16, Seg_dot
    STS   DgtVh2, r16
    RJMP  V_segRt

VlmtCur:
    LDI   r16, SEGSblk
    STS   DgtCh3, r16

V_segRt:
    RET

;--------------------------
; *R* EE initialization ***
;--------------------------

; upload SIGNAT2, Cur2bcd, Vlt2bcd, INITvHi, INITcHi  in EE if fresh
; Cur2bcd= 4000= 0x0FA0= currG_H\L, ADDRc_h = 0x0010, [H] then [L]
; Vlt2bcd= 4988= 0x137C= voltG_H\L, ADDRv_h = 0x0020, [H] then [L]
; Mvi2bcd=10192= 0x27D0= mainG_H\L, ADDRm_h = 0x0030, [H] then [L]
; INITvHi=  145= 0x0091= v_hiDecB , ADDRvHi = 0x0040, *100=[v_hiDecH\L]
; INITcHi=   20= 0x0014= c_hiDecB , ADDRcHi = 0x0050, *100=[c_hiDecH\L]
; INITzro=65535= 0xFFFF= ZroDifH\L, ADDRzro = 0x0060, [H] then [L]

EE_init:
    RCALL EE_wait               ; just in case

    OUT   EEARH, zero           ; always 0 , EEARH\L < 256

EEini_S:
    LDI   r16, 15               ; end of SIGNAT2
    OUT   EEARL, r16            ; check 0x000F instead of 0x0000

    SBI   EECR, EERE
    IN    r17, EEDR
    CPI   r17, 0xFF
    BRNE  EEiniRt               ; if sign[1] <> 0xFF , do nothing

    LDI   ZH, high(SIGNAT2*2)
    LDI   ZL,  low(SIGNAT2*2)

    LDI   r19, 16               ; to save 16 characters
    CLR   r16

SIGN_lp:
    OUT   EEARL, r16            ; start at 0x0000
    LPM   r17, Z+               ; load Indirect
    RCALL SV_byte

    INC   r16                   ; address of currG_L, 0x0011
    DEC   r19
    BRNE  SIGN_lp

EEini_A:
    LDI   r16, ADDRc_h          ; address of currG_H , 0x0010
    OUT   EEARL, r16

    LDI   r17, high(Cur2bcd)
    RCALL SV_byte

    INC   r16                   ; address of currG_L, 0x0011
    OUT   EEARL, r16
    LDI   r17, low(Cur2bcd)
    RCALL SV_byte

EEini_V:
    LDI   r16, ADDRv_h          ; address of voltG_H, 0x0020
    OUT   EEARL, r16

    LDI   r17, high(Vlt2bcd)
    RCALL SV_byte

    INC   r16                   ; address of voltG_L, 0x0021
    OUT   EEARL, r16
    LDI   r17,  low(Vlt2bcd)
    RCALL SV_byte

EEini_M:
    LDI   r16, ADDRm_h          ; address of mainG_H, 0x0030
    OUT   EEARL, r16

    LDI   r17, high(Mvi2bcd)
    RCALL SV_byte

    INC   r16                   ; address of mainG_L, 0x0031
    OUT   EEARL, r16
    LDI   r17,  low(Mvi2bcd)
    RCALL SV_byte

EEiniVh:
    LDI   r16, ADDRvHi          ; address of v_hiDecB, 0x0040
    OUT   EEARL, r16

    LDI   r17, INITvHi          ; to save nominal v_hiDecB
    RCALL SV_byte

EEiniCh:
    LDI   r16, ADDRcHi          ; address of c_hiDecB, 0x0050
    OUT   EEARL, r16

    LDI   r17, INITcHi          ; to save nominal c_hiDecB

; INITzro=0xFFFF, ADDRzro 0x0060

SV_byte:
    OUT   EEARL, r16
    OUT   EEDR, r17
    CLI                         ; disable interrupts during timed sequence
    SBI   EECR, EEMWE           ; enable EEPROM write
    SBI   EECR, EEWE            ; start EEPROM write
    SEI                         ; re-enable interrupts

EE_wait:
    SBIC  EECR, EEWE            ; wait to end previous saving
    RJMP  EE_wait

EEiniRt:
    RET

;----------------------------------
; *R* load current gain from EE ***
;----------------------------------
; download: currG_H\L

RDcurrG:
    RCALL EE_wait               ; redundant

    OUT   EEARH, zero           ; always 0 , EEARH\L < 256

    LDI   r16, ADDRc_h
    OUT   EEARL, r16            ; address of currG_H , 0x0010

    SBI   EECR, EERE
    IN    r17, EEDR
    STS   currG_H, r17

    INC   r16
    OUT   EEARL, r16            ; address of currG_L, 0x0011

    SBI   EECR, EERE
    IN    r17, EEDR
    STS   currG_L, r17

    RET

;----------------------------------
; *R* load voltage gain from EE ***
;----------------------------------
; download: voltG_H\L

RDvoltG:
    RCALL EE_wait               ; redundant

    OUT   EEARH, zero           ; always 0 , EEARH\L < 256

    LDI   r16, ADDRv_h
    OUT   EEARL, r16            ; address of voltG_H, 0x0020

    SBI   EECR, EERE
    IN    r18, EEDR
    STS   voltG_H, r18

    INC   r16
    OUT   EEARL, r16            ; address of voltG_L, 0x0021

    SBI   EECR, EERE
    IN    r17, EEDR
    STS   voltG_L, r17

    RET

;----------------------------------------
; *R* load mains voltage gain from EE ***
;----------------------------------------
; download: mainG_H\L

RDmainG:
    RCALL EE_wait               ; redundant

    OUT   EEARH, zero           ; always 0 , EEARH\L < 256

    LDI   r16, ADDRm_h
    OUT   EEARL, r16            ; address of mainG_H, 0x0030

    SBI   EECR, EERE
    IN    r18, EEDR
    STS   mainG_H, r18

    INC   r16
    OUT   EEARL, r16            ; address of voltG_L, 0x00231

    SBI   EECR, EERE
    IN    r17, EEDR
    STS   mainG_L, r17

    RET

;----------------------------------------
; *R* load high limit voltage from EE ***
;----------------------------------------
; download: value v_hiDecB and set v_hiDecH\L, DgtVh3:1

RD_V_hi:
    RCALL EE_wait               ; redundant

    OUT   EEARH, zero           ; always 0 , EEARH\L < 256

    LDI   r16, ADDRvhi
    OUT   EEARL, r16            ; address of v_hiDecB, 0x0040

    SBI   EECR, EERE
    IN    r16, EEDR
    STS   v_hiDecB, r16

    LDI   r17, 100
    MUL   r16, r17              ; v_hiDecH\L = v_hiDecB * 100
    STS   v_hiDecH, r1
    STS   v_hiDecL, r0

    MOV   r17, r1
    MOV   r16, r0
    SBR   F_usrVhi
    RCALL VlmtSeg
    CBR   F_usrVhi

    RET

;---------------------------------------
; *R* load low limit voltage from EE ***
;---------------------------------------
; download: value c_hiDecB and set c_hiDecH\L, DgtCh3:1

RD_C_hi:
    RCALL EE_wait               ; redundant

    OUT   EEARH, zero           ; always 0 , EEARH\L < 256

    LDI   r16, ADDRcHi
    OUT   EEARL, r16            ; address of c_hiDecB, 0x0050

    SBI   EECR, EERE
    IN    r16, EEDR
    STS   c_hiDecB, r16

    LDI   r17, 100
    MUL   r16, r17              ; c_hiDecH\L = c_hiDec * 100
    STS   c_hiDecH, r1
    STS   c_hiDecL, r0

    MOV   r17, r1
    MOV   r16, r0
    SBR   F_usrChi
    RCALL VlmtSeg
    CBR   F_usrChi

    RET

;---------------------------
; *R* download ZroDifH\L ***
;---------------------------
; download: ZroDifH\L

RDzroDf:
    RCALL EE_wait               ; redundant

    OUT   EEARH, zero           ; always 0 , EEARH\L < 256

    LDI   r16, ADDRzro
    OUT   EEARL, r16            ; address of ZroDifH, 0x60

    SBI   EECR, EERE
    IN    r17, EEDR
    STS   ZroDifH, r17

    INC   r16
    OUT   EEARL, r16            ; address of ZroDifL, 0x61

    SBI   EECR, EERE
    IN    r17, EEDR
    STS   ZroDifL, r17

    RET

;------------------------------------------------
; *R* Key monitoring for adjust or normal run ***
;------------------------------------------------

ISadjst:
    IN    r19, PINC             ; 1c
    ORI   r19, 0b11001111       ; 1c
    CPI   r19, NO_keys          ; 1c, 0b11111111
    BREQ  NOadjMd               ; 1c, continue if both keys not on

    LDI   r20, UP_keys          ; right key
    RCALL ADJboot
    SBRS  B_adjMod
    RJMP  NOadjMd

    SBI   UPPboot               ; Upper segment A at digit 0 or 1 is on
    LDI   r18, ADJdly1          ; 1/4 * 8 = 2 sec
ADJeLp1:
    RCALL DLYqSec
    DEC   r18
    BRNE  ADJeLp1

    LDI   r20, TWOkeys          ; both keys
    RCALL ADJboot
    SBRS  B_adjMod
    RJMP  NOadjMd

    SBI   DWNboot               ; Lower segment D at digit 0 or 1 is on
    LDI   r18, ADJdly1          ; 1/4 * 8 = 2 sec
ADJeLp2:
    RCALL DLYqSec
    DEC   r18
    BRNE  ADJeLp2

    LDI   r20, DW_keys          ; left key
    RCALL ADJboot
    SBRS  B_adjMod
    RJMP  NOadjMd

    CBI   MIDboot               ; Mid segment G at digit 0 or 1 is off

; loop till both keys are off
ENDwait:
    IN    r16, KEYs_In
    ORI   r16, TWOkeys
    CPI   r16, NO_keys
    BRNE  ENDwait

    CBI   UPPboot               ; Upper segment A at digit 0 or 1 is off
    SBI   MIDboot               ; Mid   segment G at digit 0 or 1 is on
    CBI   DWNboot               ; Lower segment D at digit 0 or 1 is off
NOadjMd:
    RET

;---------------------------------------------------
; *R* Key monitoring for 2 sec for office adjust ***
;---------------------------------------------------
;  in: r20 as UP_keys, DW_keys or TWOkeys
; out: F_adjMod if r20 keys are pressed for 2s each

ADJboot:
    CBR   F_adjMod

    CLR   r16
    CLR   r17

; 1/8MHz*(35*7c)*256*256 =~ 2s
    LDI   r18, ADJdly2

ADJloop:
    IN    r19, PINC             ; 1c
    ORI   r19, 0b11001111       ; 1c
    CP    r19, r20              ; 1c, 0b11??1111
    BRNE  ADJbtRt               ; 1c, continue if both keys not on

    DEC   r16
    BRNE  ADJloop               ; 3c, 7c

    DEC   r17
    BRNE  ADJloop               ; 3c

    DEC   r18
    BRNE  ADJloop               ; 3c

    SBR   F_adjMod

ADJbtRt:
    RET

;==========================================
;==========================================
;==========================================

;===================================================
; Division 24/16, 429 cycles, rounding res_U\H\L ***
;===================================================
; dividend : r18:r17:r16
; divisor  : r20:r19
; remainder: r14:r13
; loopCount: r21(steps=25)
; result   : r2:r1:r0 , 414 cycles
; maximum tested 414 cycles + 15 for rounding

; if division 24/8, r20=0

; 12 bytes + SREG (in case PUSH and POP)

D24u16rd:
    CLR   r13
    SUB   r14, r14              ; to clear carry
    LDI   r21, 25
    RJMP  D24u16u1

D24u16u2:
    ROL   r13
    ROL   r14
    SUB   r13, r19
    SBC   r14, r20
    BRCC  D24u16u3

    ROL   r0
    ROL   r1
    ROL   r2
    ADD   r13, r19
    ADC   r14, r20
D24u16u1:
    ROL   r16
    ROL   r17
    ROL   r18
    DEC   r21
    BRNE  D24u16u2

    COM   r0
    COM   r1
    COM   r2

; rounding begin
    LSR   r20                   ; carry=0
    ROR   r19
    CP    r19, r13
    CPC   r20, r14
    BRSH  D24u16uR              ; if divisor/2 > remainder, skip rounding

    INC   r0                    ; add 1 to resultL
    BRNE  D24u16uR              ; if resultL becomes 0, resultH+1

    INC   r1
    BRNE  D24u16uR              ; if resultH not zero, skip

    INC   r2
    BRNE  D24u16uR              ; if resultU not zero, skip

    DEC   r2
    DEC   r1
    DEC   r0
D24u16uR:
; rounding end
    RET

D24u16u3:
    ROL   r0
    ROL   r1
    ROL   r2
    RJMP  D24u16u1

; 4:11 PM 8/12/2017
;===============================================
; Division 16/16, 280 cycles, rounding r1:r0 ***
;===============================================
; dividend : r17:r16
; divisor  : r20:r19
; remainder: r14:r13
; loopCount: r21(steps)
; result   : r1:r0, 280 cycles

; if division 16/8, r19=0

D16u16rd:
    CLR   r13
    SUB   r14, r14              ; to clear carry
    LDI   r21, 17
    RJMP  D16u16u1

D16u16u2:
    ROL   r13
    ROL   r14
    SUB   r13, r19
    SBC   r14, r20
    BRCC  D16u16u3

    ROL   r0
    ROL   r1
    ADD   r13, r19
    ADC   r14, r20
D16u16u1:
    ROL   r16
    ROL   r17
    DEC   r21
    BRNE  D16u16u2

    COM   r0
    COM   r1

    CLC
    ROR   r20                   ; carry=0
    ROR   r19
    CP    r19, r13
    CPC   r20, r14
    BRSH  D16u16uR              ; if divisor/2 > remainder, skip rounding

    INC   r0                    ; add 1 to resultL
    BRNE  D16u16uR              ; if resultL becomes 0, resultH+1

    INC   r1
    BRNE  D16u16uR              ; if resultH not zero, skip

    DEC   r1
    DEC   r0
D16u16uR:
    RET

D16u16u3:
    ROL   r0
    ROL   r1
    RJMP  D16u16u1

;------------------------------------------
; *** 16x16 Bit Unsigned Multiplication ***
;------------------------------------------
; [ 16x16 Bit Unsigned Multiplication ]
; multiplicand: r17:r16
; multiplier  : r14:r13
; result out  : r21:r20:r19:r18
; see mul16x16_32_AL.txt
; 23 cycles , r15=zero
M_16x16:                        ;3a
    MUL   r17, r14              ;2a, ah * bh
    MOVW  r21:r20, r1:r0        ;1a
    MUL   r16, r13              ;2a, al * bl
    MOVW  r19:r18, r1:r0        ;1a
    MUL   r17, r13              ;2a, ah * bl
    ADD   r19, r0               ;1a
    ADC   r20, r1               ;1a               
    ADC   r21, zero             ;1a
    MUL   r14, r16              ;2a, bh * al
    ADD   r19, r0               ;1a
    ADC   r20, r1               ;1a
    ADC   r21, zero             ;1a
    RET                         ;4a

;-----------------------------------------------------
; *** 16x8 Bit Unsigned Multiplication, +10 cycles ***
;-----------------------------------------------------
; multiplicand: r17:r16
; multiplier  : r20 [destroyed]
; result out  : r20(U), r19(H), r18(L)
; see 16mul8_AL.txt
; 10 + RET[4] + CALL[4] or RCALL[3]= 17 cycles

M_16x8_:
    MUL   r16, r20              ;  r1 = AlBl_H , r0 = AlBl_L
    MOV   r18, r0               ; r18 = AlBl_L
    MOV   r19, r1               ; r19 = AlBl_H
    MUL   r17, r20              ;  r1 = AhBl_H , r0 = AhBl_L
    ADD   r19, r0               ; r19 = AhBl_L + AlBl_H
    CLR   r0                    ;  r0 = 0
    ADC   r1, r0                ;  r1 = AhBl_H + carry
    MOV   r20, r1               ; r20 = AhBl_H + carry
    RET

;====================================
; *R* quasi-decimal binary to BCD ***
;====================================
; input: R17, R16 = 16 bit; value 0 to 65535
;output: R20, R19, R18, R17, R16 = 5 digits (ASCII)
; 60909 [+175a+7a=182a]
;  0909 [+145a+7a=152a]
;    09 [+100a+7a=107a]

DEC2BCD:
    LDI   r20, -1               ; -1 will be 0 at first pass
_bcd1:
    INC   r20
    SUBI  r16, low(10000)       ; -10000 because r17:r16 positive
    SBCI  r17, high(10000)
    BRCC  _bcd1
;---
    LDI   r19, 10               ; 10 will be 9 at first pass
_bcd2:
    DEC   r19
    SUBI  r16, low(-1000)       ; +1000 because r17:r16 negative
    SBCI  r17, high(-1000)
    BRCS  _bcd2
;---
    LDI   r18, -1               ; -1 will be 0 at first pass
_bcd3:
    INC   r18
    SUBI  r16, low(100)         ; -100 because r17:r16 positive
    SBCI  r17, high(100)
    BRCC  _bcd3

    LDI   r17, 10               ; 10 will be 9 at first pass
_bcd4:
    DEC   r17
    SUBI  r16, -10              ; +10 because r17:r16 negative
    BRCS  _bcd4

    RET                         ; r17:r16 positive

;===================================
; Multiplication 16 * 8 unsigned ***
;===================================
; multiplicand: r17:r16
; multiplier  : r20
; result out  : r20:r19:r18
; see 16mul8_AL.txt
MUL16_8:
    MUL   r16, r20
    MOV   r18, r0
    MOV   r19, r1
    MUL   r17, r20
    MOV   r20, r1
    ADD   r19, r0
    ADC   r20, zero
    RET

;=======================================
; *F* halt and display a fatal error ***
;=======================================

; ABS new zero difference > ZROlimt [300, ~3A]
FTLerr1:
    LDI   r16, SEGS_1_
    STS   DigtA1, r16
FTL1err:
    LDI   r16, SEGS_r_
    STS   DigtA2, r16

FTL2err:
    LDI   r16, SEGS__E
    STS   DigtA3, r16

    SBR   F_shwLmt              ; to enable RET of SHWdspl:
    SBR   F_ampMod
    CBR   F_vltMod
    CBR   F_usrVhi
    CBR   F_usrChi

FTLloop:
    LDI   r17, 2
    RCALL DLYmSec

    RCALL SHWdspl

    SBIC  KEYupIn
    RJMP  FTLloop

    SBIS  KEYdwIn
    RJMP  RESET                 ; reboot if both keys pressed

    RJMP  FTLloop

;===

; reserved
FTLerr2:
    LDI   r16, SEGS_2_
    STS   DigtA1, r16
    RJMP  FTL1err

;===

; reserved
FTLerr3:
    LDI   r16, SEGS_3_
    STS   DigtA1, r16
    RJMP  FTL1err

;===

; reserved
FTLerr4:
    LDI   r16, SEGS_4_
    STS   DigtA1, r16
    RJMP  FTL1err

;===

; reserved
FTLerr5:
    LDI   r16, SEGS_5_
    STS   DigtA1, r16
    RJMP  FTL1err

;===

; reserved
FTLerr6:
    LDI   r16, SEGS_6_
    STS   DigtA1, r16
    RJMP  FTL1err

;===

; reserved
FTLerr7:
    LDI   r16, SEGS_7_
    STS   DigtA1, r16
    RJMP  FTL1err

; reserved
FTLerr8:
    LDI   r16, SEGS_7_
    STS   DigtA1, r16
    RJMP  FTL1err

; reserved
FTLerr9:
    LDI   r16, SEGS_7_
    STS   DigtA1, r16
    RJMP  FTL1err

;===

; Ibatt < 9.0A
FTLer10:
    LDI   r16, SEGS_0_
    STS   DigtA1, r16
FTL3err:
    LDI   r16, SEGS_1_
    STS   DigtA2, r16
    RJMP  FTL2err

;===

; Ibatt > 11.0A
FTLer11:
    LDI   r16, SEGS_1_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; Vbatt < 11V
FTLer12:
    LDI   r16, SEGS_2_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; Vbatt > 12V5
FTLer13:
    LDI   r16, SEGS_3_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; reserved
FTLer14:
    LDI   r16, SEGS_4_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; reserved
FTLer15:
    LDI   r16, SEGS_5_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; reserved
FTLer16:
    LDI   r16, SEGS_6_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; reserved
FTLer17:
    LDI   r16, SEGS_7_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; reserved
FTLer18:
    LDI   r16, SEGS_8_
    STS   DigtA1, r16
    RJMP  FTL3err

;===

; reserved
FTLer19:
    LDI   r16, SEGS_9_
    STS   DigtA1, r16
    RJMP  FTL3err

;----------------------------------
;----------------------------------
; *R* Delay, multiple of 1 msec *** 8 MHz
;----------------------------------
;----------------------------------
; r17 = t (ms)
; used and then restored: r16 and r17
; delay= [ (28+3)*256 + (4+3*20) ] * 250 * 0.125 = 250 ms

DLYqSec:                        ;+2c call
    PUSH   r17                  ; 2c, added
    LDI    r17, simuDly         ; 1c
    RJMP   DLYsecC              ; 2c, added

DLYmSec:
    PUSH   r17                  ; 2c, added
DLYsecC:
    PUSH   r16                  ; 2c, added
DLYsecL:
    CLR    r16                  ; 1c
DlyM_lp:
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    NOP                         ; 1c
    DEC   r16                   ; 1c
    BRNE  DlyM_lp               ; 3/2c

    LDI   r16, 20               ; 1c
    NOP                         ; 1c, added for timing
INNERlp:
    DEC   r16                   ; 1c
    BRNE  INNERlp               ; 3/2c

    DEC   r17                   ; 1c
    BRNE  DLYsecL               ; 3/2c

    POP   r16                   ; 2c, added
    POP   r17                   ; 2c, added
    RET                         ; 4c

;====================================================================
;====================================================================
;====================================================================

;---------------
; *** Tables ***
;---------------

    .org 0x0D00

PWM_max:
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   0
    .dw   340                   ;   159 Vrms
    .dw   340                   ;   160 Vrms
    .dw   340                   ;   161 Vrms
    .dw   340                   ;   162 Vrms
    .dw   340                   ;   163 Vrms
    .dw   340                   ;   164 Vrms
    .dw   340                   ;   165 Vrms
    .dw   340                   ;   166 Vrms
    .dw   340                   ;   167 Vrms
    .dw   340                   ;   168 Vrms
    .dw   340                   ;   169 Vrms
    .dw   340                   ;   170 Vrms
    .dw   338                   ;   171 Vrms
    .dw   336                   ;   172 Vrms
    .dw   334                   ;   173 Vrms
    .dw   332                   ;   174 Vrms
    .dw   330                   ;   175 Vrms
    .dw   328                   ;   176 Vrms
    .dw   326                   ;   177 Vrms
    .dw   325                   ;   178 Vrms
    .dw   323                   ;   179 Vrms
    .dw   321                   ;   180 Vrms
    .dw   319                   ;   181 Vrms
    .dw   318                   ;   182 Vrms
    .dw   316                   ;   183 Vrms
    .dw   314                   ;   184 Vrms
    .dw   312                   ;   185 Vrms
    .dw   311                   ;   186 Vrms
    .dw   309                   ;   187 Vrms
    .dw   307                   ;   188 Vrms
    .dw   306                   ;   189 Vrms
    .dw   304                   ;   190 Vrms
    .dw   303                   ;   191 Vrms
    .dw   301                   ;   192 Vrms
    .dw   299                   ;   193 Vrms
    .dw   298                   ;   194 Vrms
    .dw   296                   ;   195 Vrms
    .dw   295                   ;   196 Vrms
    .dw   293                   ;   197 Vrms
    .dw   292                   ;   198 Vrms
    .dw   290                   ;   199 Vrms
    .dw   289                   ;   200 Vrms
    .dw   287                   ;   201 Vrms
    .dw   286                   ;   202 Vrms
    .dw   285                   ;   203 Vrms
    .dw   283                   ;   204 Vrms
    .dw   282                   ;   205 Vrms
    .dw   280                   ;   206 Vrms
    .dw   279                   ;   207 Vrms
    .dw   278                   ;   208 Vrms
    .dw   276                   ;   209 Vrms
    .dw   275                   ;   210 Vrms
    .dw   274                   ;   211 Vrms
    .dw   273                   ;   212 Vrms
    .dw   271                   ;   213 Vrms
    .dw   270                   ;   214 Vrms
    .dw   269                   ;   215 Vrms
    .dw   267                   ;   216 Vrms
    .dw   266                   ;   217 Vrms
    .dw   265                   ;   218 Vrms
    .dw   264                   ;   219 Vrms
    .dw   263                   ;   220 Vrms
    .dw   261                   ;   221 Vrms
    .dw   260                   ;   222 Vrms
    .dw   259                   ;   223 Vrms
    .dw   258                   ;   224 Vrms
    .dw   257                   ;   225 Vrms
    .dw   256                   ;   226 Vrms
    .dw   254                   ;   227 Vrms
    .dw   253                   ;   228 Vrms
    .dw   252                   ;   229 Vrms
    .dw   251                   ;   230 Vrms
    .dw   250                   ;   231 Vrms
    .dw   249                   ;   232 Vrms
    .dw   248                   ;   233 Vrms
    .dw   247                   ;   234 Vrms
    .dw   246                   ;   235 Vrms
    .dw   245                   ;   236 Vrms
    .dw   244                   ;   237 Vrms
    .dw   243                   ;   238 Vrms
    .dw   242                   ;   239 Vrms
    .dw   241                   ;   240 Vrms
    .dw   240                   ;   241 Vrms
    .dw   239                   ;   242 Vrms
    .dw   238                   ;   243 Vrms
    .dw   237                   ;   244 Vrms
    .dw   236                   ;   245 Vrms
    .dw   235                   ;   246 Vrms
    .dw   234                   ;   247 Vrms
    .dw   233                   ;   248 Vrms
    .dw   232                   ;   249 Vrms
    .dw   231                   ;   250 Vrms
    .dw   230                   ;   251 Vrms
    .dw   229                   ;   252 Vrms
    .dw   228                   ;   253 Vrms
    .dw   227                   ;   254 Vrms
    .dw     0                   ;   255 Vrms

;=========================================================
;=========================================================

    .org 0x0E00


DIGTtbl:
;        bfaedpcg
   .db 0b11111010, 0b10000010 ; 0  , 0xFA  ; 1  , 0x82
   .db 0b10111001, 0b10101011 ; 2  , 0xB9  ; 3  , 0xAB
   .db 0b11000011, 0b01101011 ; 4  , 0xC3  ; 5  , 0x6B
   .db 0b01111011, 0b10100010 ; 6  , 0x7B  ; 7  , 0xA2
   .db 0b11111011, 0b11101011 ; 8  , 0xFB  ; 9  , 0xEB

Symbols:
;                bfaedpcg
.equ SEGS_0_ = 0b11111010 ; 0xFA
.equ SEGS_1_ = 0b10000010 ; 0x82
.equ SEGS_2_ = 0b10111001 ; 0xB9
.equ SEGS_3_ = 0b10101011 ; 0xAB
.equ SEGS_4_ = 0b11000011 ; 0xC3
.equ SEGS_5_ = 0b01101011 ; 0x6B
.equ SEGS_6_ = 0b01111011 ; 0x7B
.equ SEGS_7_ = 0b10100010 ; 0xA2
.equ SEGS_8_ = 0b11111011 ; 0xFB
.equ SEGS_9_ = 0b11101011 ; 0xEB
.equ SEGSblk = 0b00000000 ; 0x00
.equ SEGS_lo = 0b00001000 ; 0x08
.equ SEGS_md = 0b00000001 ; 0x01
.equ SEGS_hi = 0b00100000 ; 0x20
.equ SEGS__L = 0b01011000 ; 0x58
.equ SEGS__H = 0b11010011 ; 0xD3
.equ SEGS__E = 0b01111001 ; 0x79
.equ SEGS_r_ = 0b00010001 ; 0x11
.equ SEGS_u_ = 0b00011010 ; 0x1A
.equ SEGS_t_ = 0b01011001 ; 0x59
.equ SEGS_o_ = 0b00011011 ; 0x1B
.equ SEGS__C = 0b01111000 ; 0x78
.equ SEGS_c_ = 0b00011001 ; 0x19
.equ SEGS_d_ = 0b10011011 ; 0x9B
.equ SEGS__U = 0b11011010 ; 0xDA
.equ SEGS__A = 0b11110011 ; 0xF3
.equ SEGS_n_ = 0b00010011 ; 0x13
.equ SEGS__F = 0b01110001 ; 0x71
.equ SEGS__P = 0b11110001 ; 0xF1

.equ SGminus = 0b00000001 ; 0x01

;-----------------------
; *** Indirect jumps ***
;-----------------------

    .org 0x0F00

; [92a+15a=107a] common cycles, [max=832a] 
SMPL000: RJMP  CUR2dec ; 107a+ 61a=168a
SMPL001: RJMP  VLT2dec ; 107a+ 50a=157a
SMPL002: RJMP  MVI2dec ; 107a+118a=225a
SMPL003: RJMP  CUR2seg ; 107a+209a=316a
SMPL004: RJMP  VLT2seg ; 107a+257a=364a
SMPL005: RJMP  MVI2seg ; 107a+198a=305a
SMPL006: RJMP  CHK_max ; check maximum current and voltage
SMPL007: RJMP  SETzero ;
SMPL008: RJMP  KEYhigh ; user setting of voltage maximum by DW_keys
SMPL009: RJMP  KEY_low ; user setting of current maximum by DW_keys
SMPL010: RJMP  KEYSadj ;
SMPL011: RJMP  SHWdspl ;
SMPL012: RJMP  ADJ_set ;
SMPL013: RJMP  SCRNmod ;
SMPL014: RJMP  END_act ;
SMPL015: RJMP  SAVEval ;
SMPL016: RJMP  END_act ;
SMPL017: RJMP  END_act ;
SMPL018: RJMP  END_act ;
SMPL019: RJMP  END_act ;
SMPL020: RJMP  END_act ;
SMPL021: RJMP  END_act ;
SMPL022: RJMP  END_act ;
SMPL023: RJMP  SHWdspl ;

;====
;.ESEG
;====

;    .org 0x0000

;0x0000: .db   SIGNAT2 [16 bytes]
;0x0010: .db   currG_H , currG_L,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
;0x0020: .db   voltG_H , voltG_L,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
;0x0030: .db   mainG_H , voltG_L,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
;0x0040: .db   v_hiDecB, 0xFF   ,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
;0x0050: .db   c_hiDecB, 0xFF   ,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
;0x0060: .db   ZroDifH,  ZroDifL,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF

;initial values:
; currG_H\L = Cur2bcd = 4200
; voltG_H\L = Vlt2bcd = 5196
; mainG_H\L = Mvi2bcd = 10192
;  v_hiDecB = 145 [as 14V5, mid of 13V5 and 16V0]
;  c_hiDecB =  20 [as 20A0, lowest 5A0]

.exit

/*
;----------------------------------------------------------------------
; DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT - DRAFT
;----------------------------------------------------------------------

*/
